pragma Warnings (Off);
pragma Ada_95;
with System;
with System.Parameters;
with System.Secondary_Stack;
package ada_main is

   gnat_argc : Integer;
   gnat_argv : System.Address;
   gnat_envp : System.Address;

   pragma Import (C, gnat_argc);
   pragma Import (C, gnat_argv);
   pragma Import (C, gnat_envp);

   gnat_exit_status : Integer;
   pragma Import (C, gnat_exit_status);

   GNAT_Version : constant String :=
                    "GNAT Version: 14.0.1 20240411 (Red Hat 14.0.1-0)" & ASCII.NUL;
   pragma Export (C, GNAT_Version, "__gnat_version");

   GNAT_Version_Address : constant System.Address := GNAT_Version'Address;
   pragma Export (C, GNAT_Version_Address, "__gnat_version_address");

   Ada_Main_Program_Name : constant String := "_ada_gnatlink" & ASCII.NUL;
   pragma Export (C, Ada_Main_Program_Name, "__gnat_ada_main_program_name");

   procedure adainit;
   pragma Export (C, adainit, "adainit");

   procedure adafinal;
   pragma Export (C, adafinal, "adafinal");

   function main
     (argc : Integer;
      argv : System.Address;
      envp : System.Address)
      return Integer;
   pragma Export (C, main, "main");

   type Version_32 is mod 2 ** 32;
   u00001 : constant Version_32 := 16#7a0fd82b#;
   pragma Export (C, u00001, "gnatlinkB");
   u00002 : constant Version_32 := 16#e72e593c#;
   pragma Export (C, u00002, "gnatlinkS");
   u00003 : constant Version_32 := 16#30305195#;
   pragma Export (C, u00003, "system__standard_libraryB");
   u00004 : constant Version_32 := 16#eb789e79#;
   pragma Export (C, u00004, "system__standard_libraryS");
   u00005 : constant Version_32 := 16#76789da1#;
   pragma Export (C, u00005, "adaS");
   u00006 : constant Version_32 := 16#13245dc2#;
   pragma Export (C, u00006, "ada__command_lineB");
   u00007 : constant Version_32 := 16#3cdef8c9#;
   pragma Export (C, u00007, "ada__command_lineS");
   u00008 : constant Version_32 := 16#f97639e0#;
   pragma Export (C, u00008, "systemS");
   u00009 : constant Version_32 := 16#524f7d04#;
   pragma Export (C, u00009, "system__secondary_stackB");
   u00010 : constant Version_32 := 16#57bd68ec#;
   pragma Export (C, u00010, "system__secondary_stackS");
   u00011 : constant Version_32 := 16#7703497c#;
   pragma Export (C, u00011, "ada__exceptionsB");
   u00012 : constant Version_32 := 16#89876bf3#;
   pragma Export (C, u00012, "ada__exceptionsS");
   u00013 : constant Version_32 := 16#0740df23#;
   pragma Export (C, u00013, "ada__exceptions__last_chance_handlerB");
   u00014 : constant Version_32 := 16#a028f72d#;
   pragma Export (C, u00014, "ada__exceptions__last_chance_handlerS");
   u00015 : constant Version_32 := 16#fd5f5f4c#;
   pragma Export (C, u00015, "system__soft_linksB");
   u00016 : constant Version_32 := 16#a802761d#;
   pragma Export (C, u00016, "system__soft_linksS");
   u00017 : constant Version_32 := 16#0286ce9f#;
   pragma Export (C, u00017, "system__soft_links__initializeB");
   u00018 : constant Version_32 := 16#2ed17187#;
   pragma Export (C, u00018, "system__soft_links__initializeS");
   u00019 : constant Version_32 := 16#a43efea2#;
   pragma Export (C, u00019, "system__parametersB");
   u00020 : constant Version_32 := 16#cce1c5f1#;
   pragma Export (C, u00020, "system__parametersS");
   u00021 : constant Version_32 := 16#8599b27b#;
   pragma Export (C, u00021, "system__stack_checkingB");
   u00022 : constant Version_32 := 16#3e292cf6#;
   pragma Export (C, u00022, "system__stack_checkingS");
   u00023 : constant Version_32 := 16#35a8ed08#;
   pragma Export (C, u00023, "system__storage_elementsS");
   u00024 : constant Version_32 := 16#c71e6c8a#;
   pragma Export (C, u00024, "system__exception_tableB");
   u00025 : constant Version_32 := 16#745d4ff9#;
   pragma Export (C, u00025, "system__exception_tableS");
   u00026 : constant Version_32 := 16#cbd386d2#;
   pragma Export (C, u00026, "system__exceptionsS");
   u00027 : constant Version_32 := 16#69416224#;
   pragma Export (C, u00027, "system__exceptions__machineB");
   u00028 : constant Version_32 := 16#46355a4a#;
   pragma Export (C, u00028, "system__exceptions__machineS");
   u00029 : constant Version_32 := 16#7706238d#;
   pragma Export (C, u00029, "system__exceptions_debugB");
   u00030 : constant Version_32 := 16#c97861b3#;
   pragma Export (C, u00030, "system__exceptions_debugS");
   u00031 : constant Version_32 := 16#dbe97aa1#;
   pragma Export (C, u00031, "system__img_intS");
   u00032 : constant Version_32 := 16#f2c63a02#;
   pragma Export (C, u00032, "ada__numericsS");
   u00033 : constant Version_32 := 16#174f5472#;
   pragma Export (C, u00033, "ada__numerics__big_numbersS");
   u00034 : constant Version_32 := 16#035c46b9#;
   pragma Export (C, u00034, "system__unsigned_typesS");
   u00035 : constant Version_32 := 16#5c7d9c20#;
   pragma Export (C, u00035, "system__tracebackB");
   u00036 : constant Version_32 := 16#7feccd5d#;
   pragma Export (C, u00036, "system__tracebackS");
   u00037 : constant Version_32 := 16#5f6b6486#;
   pragma Export (C, u00037, "system__traceback_entriesB");
   u00038 : constant Version_32 := 16#316a866c#;
   pragma Export (C, u00038, "system__traceback_entriesS");
   u00039 : constant Version_32 := 16#a0281f47#;
   pragma Export (C, u00039, "system__traceback__symbolicB");
   u00040 : constant Version_32 := 16#140ceb78#;
   pragma Export (C, u00040, "system__traceback__symbolicS");
   u00041 : constant Version_32 := 16#701f9d88#;
   pragma Export (C, u00041, "ada__exceptions__tracebackB");
   u00042 : constant Version_32 := 16#26ed0985#;
   pragma Export (C, u00042, "ada__exceptions__tracebackS");
   u00043 : constant Version_32 := 16#a0d3d22b#;
   pragma Export (C, u00043, "system__address_imageB");
   u00044 : constant Version_32 := 16#589aa4da#;
   pragma Export (C, u00044, "system__address_imageS");
   u00045 : constant Version_32 := 16#fd158a37#;
   pragma Export (C, u00045, "system__wch_conB");
   u00046 : constant Version_32 := 16#20751a83#;
   pragma Export (C, u00046, "system__wch_conS");
   u00047 : constant Version_32 := 16#5c289972#;
   pragma Export (C, u00047, "system__wch_stwB");
   u00048 : constant Version_32 := 16#0d643682#;
   pragma Export (C, u00048, "system__wch_stwS");
   u00049 : constant Version_32 := 16#7cd63de5#;
   pragma Export (C, u00049, "system__wch_cnvB");
   u00050 : constant Version_32 := 16#26b5d0f3#;
   pragma Export (C, u00050, "system__wch_cnvS");
   u00051 : constant Version_32 := 16#9111f9c1#;
   pragma Export (C, u00051, "interfacesS");
   u00052 : constant Version_32 := 16#e538de43#;
   pragma Export (C, u00052, "system__wch_jisB");
   u00053 : constant Version_32 := 16#9302b2d9#;
   pragma Export (C, u00053, "system__wch_jisS");
   u00054 : constant Version_32 := 16#634de29b#;
   pragma Export (C, u00054, "aliB");
   u00055 : constant Version_32 := 16#d40682d6#;
   pragma Export (C, u00055, "aliS");
   u00056 : constant Version_32 := 16#17b710b4#;
   pragma Export (C, u00056, "butilB");
   u00057 : constant Version_32 := 16#02d57147#;
   pragma Export (C, u00057, "butilS");
   u00058 : constant Version_32 := 16#b5988c27#;
   pragma Export (C, u00058, "gnatS");
   u00059 : constant Version_32 := 16#660dd801#;
   pragma Export (C, u00059, "optB");
   u00060 : constant Version_32 := 16#9c9fbe2c#;
   pragma Export (C, u00060, "optS");
   u00061 : constant Version_32 := 16#b5366062#;
   pragma Export (C, u00061, "csetsB");
   u00062 : constant Version_32 := 16#e948558f#;
   pragma Export (C, u00062, "csetsS");
   u00063 : constant Version_32 := 16#e259c480#;
   pragma Export (C, u00063, "system__assertionsB");
   u00064 : constant Version_32 := 16#df75467b#;
   pragma Export (C, u00064, "system__assertionsS");
   u00065 : constant Version_32 := 16#8b2c6428#;
   pragma Export (C, u00065, "ada__assertionsB");
   u00066 : constant Version_32 := 16#cc3ec2fd#;
   pragma Export (C, u00066, "ada__assertionsS");
   u00067 : constant Version_32 := 16#3b0dbbfa#;
   pragma Export (C, u00067, "hostparmS");
   u00068 : constant Version_32 := 16#ca878138#;
   pragma Export (C, u00068, "system__concat_2B");
   u00069 : constant Version_32 := 16#4c8d4a17#;
   pragma Export (C, u00069, "system__concat_2S");
   u00070 : constant Version_32 := 16#d4e0603b#;
   pragma Export (C, u00070, "typesB");
   u00071 : constant Version_32 := 16#676f845e#;
   pragma Export (C, u00071, "typesS");
   u00072 : constant Version_32 := 16#ec48c658#;
   pragma Export (C, u00072, "system__compare_array_unsigned_8B");
   u00073 : constant Version_32 := 16#6990a783#;
   pragma Export (C, u00073, "system__compare_array_unsigned_8S");
   u00074 : constant Version_32 := 16#74e358eb#;
   pragma Export (C, u00074, "system__address_operationsB");
   u00075 : constant Version_32 := 16#87421540#;
   pragma Export (C, u00075, "system__address_operationsS");
   u00076 : constant Version_32 := 16#256dbbe5#;
   pragma Export (C, u00076, "system__stringsB");
   u00077 : constant Version_32 := 16#62f439f8#;
   pragma Export (C, u00077, "system__stringsS");
   u00078 : constant Version_32 := 16#a61ae265#;
   pragma Export (C, u00078, "outputB");
   u00079 : constant Version_32 := 16#dfee97b2#;
   pragma Export (C, u00079, "outputS");
   u00080 : constant Version_32 := 16#94d23d25#;
   pragma Export (C, u00080, "system__atomic_operations__test_and_setB");
   u00081 : constant Version_32 := 16#57acee8e#;
   pragma Export (C, u00081, "system__atomic_operations__test_and_setS");
   u00082 : constant Version_32 := 16#3e1543c5#;
   pragma Export (C, u00082, "system__atomic_operationsS");
   u00083 : constant Version_32 := 16#553a519e#;
   pragma Export (C, u00083, "system__atomic_primitivesB");
   u00084 : constant Version_32 := 16#b22932a7#;
   pragma Export (C, u00084, "system__atomic_primitivesS");
   u00085 : constant Version_32 := 16#0390ef72#;
   pragma Export (C, u00085, "interfaces__cB");
   u00086 : constant Version_32 := 16#f7332afe#;
   pragma Export (C, u00086, "interfaces__cS");
   u00087 : constant Version_32 := 16#29c68ba2#;
   pragma Export (C, u00087, "system__os_libB");
   u00088 : constant Version_32 := 16#031ae9bf#;
   pragma Export (C, u00088, "system__os_libS");
   u00089 : constant Version_32 := 16#b98923bf#;
   pragma Export (C, u00089, "system__case_utilB");
   u00090 : constant Version_32 := 16#3665eeb5#;
   pragma Export (C, u00090, "system__case_utilS");
   u00091 : constant Version_32 := 16#72525e6f#;
   pragma Export (C, u00091, "system__crtlS");
   u00092 : constant Version_32 := 16#1a8ff72f#;
   pragma Export (C, u00092, "nametB");
   u00093 : constant Version_32 := 16#bc7da6aa#;
   pragma Export (C, u00093, "nametS");
   u00094 : constant Version_32 := 16#91fc5baa#;
   pragma Export (C, u00094, "debugB");
   u00095 : constant Version_32 := 16#1ac546f9#;
   pragma Export (C, u00095, "debugS");
   u00096 : constant Version_32 := 16#5be1895f#;
   pragma Export (C, u00096, "widecharB");
   u00097 : constant Version_32 := 16#fc939d63#;
   pragma Export (C, u00097, "widecharS");
   u00098 : constant Version_32 := 16#1b78961f#;
   pragma Export (C, u00098, "allocS");
   u00099 : constant Version_32 := 16#d51ad27f#;
   pragma Export (C, u00099, "tableB");
   u00100 : constant Version_32 := 16#f93c8813#;
   pragma Export (C, u00100, "tableS");
   u00101 : constant Version_32 := 16#8f2423cb#;
   pragma Export (C, u00101, "system__memoryB");
   u00102 : constant Version_32 := 16#e1e2a5fa#;
   pragma Export (C, u00102, "system__memoryS");
   u00103 : constant Version_32 := 16#9b950d9a#;
   pragma Export (C, u00103, "fnameB");
   u00104 : constant Version_32 := 16#cdf3f413#;
   pragma Export (C, u00104, "fnameS");
   u00105 : constant Version_32 := 16#26305230#;
   pragma Export (C, u00105, "gnat__dynamic_htablesB");
   u00106 : constant Version_32 := 16#2317962f#;
   pragma Export (C, u00106, "gnat__dynamic_htablesS");
   u00107 : constant Version_32 := 16#f2ec6d60#;
   pragma Export (C, u00107, "osintB");
   u00108 : constant Version_32 := 16#92046caf#;
   pragma Export (C, u00108, "osintS");
   u00109 : constant Version_32 := 16#c82691db#;
   pragma Export (C, u00109, "fmapB");
   u00110 : constant Version_32 := 16#19fb29a0#;
   pragma Export (C, u00110, "fmapS");
   u00111 : constant Version_32 := 16#9f9cc922#;
   pragma Export (C, u00111, "gnat__htableB");
   u00112 : constant Version_32 := 16#4a45b320#;
   pragma Export (C, u00112, "gnat__htableS");
   u00113 : constant Version_32 := 16#3548d972#;
   pragma Export (C, u00113, "system__htableB");
   u00114 : constant Version_32 := 16#78af610b#;
   pragma Export (C, u00114, "system__htableS");
   u00115 : constant Version_32 := 16#1f1abe38#;
   pragma Export (C, u00115, "system__string_hashB");
   u00116 : constant Version_32 := 16#dfeae174#;
   pragma Export (C, u00116, "system__string_hashS");
   u00117 : constant Version_32 := 16#8543fa0e#;
   pragma Export (C, u00117, "gnatvsnB");
   u00118 : constant Version_32 := 16#dc334c14#;
   pragma Export (C, u00118, "gnatvsnS");
   u00119 : constant Version_32 := 16#7970df99#;
   pragma Export (C, u00119, "sdefaultB");
   u00120 : constant Version_32 := 16#2b49f98f#;
   pragma Export (C, u00120, "sdefaultS");
   u00121 : constant Version_32 := 16#c781d600#;
   pragma Export (C, u00121, "targparmB");
   u00122 : constant Version_32 := 16#c8d35e80#;
   pragma Export (C, u00122, "targparmS");
   u00123 : constant Version_32 := 16#29e0a804#;
   pragma Export (C, u00123, "ridentS");
   u00124 : constant Version_32 := 16#77c57089#;
   pragma Export (C, u00124, "snamesB");
   u00125 : constant Version_32 := 16#a0667f8a#;
   pragma Export (C, u00125, "snamesS");
   u00126 : constant Version_32 := 16#896e4d40#;
   pragma Export (C, u00126, "casingB");
   u00127 : constant Version_32 := 16#cdd9f882#;
   pragma Export (C, u00127, "casingS");
   u00128 : constant Version_32 := 16#0a85a591#;
   pragma Export (C, u00128, "indepswB");
   u00129 : constant Version_32 := 16#160faade#;
   pragma Export (C, u00129, "indepswS");
   u00130 : constant Version_32 := 16#b59c4853#;
   pragma Export (C, u00130, "interfaces__c__stringsB");
   u00131 : constant Version_32 := 16#fecad76a#;
   pragma Export (C, u00131, "interfaces__c__stringsS");
   u00132 : constant Version_32 := 16#1cacf006#;
   pragma Export (C, u00132, "interfaces__c_streamsB");
   u00133 : constant Version_32 := 16#d07279c2#;
   pragma Export (C, u00133, "interfaces__c_streamsS");
   u00134 : constant Version_32 := 16#52ebc05d#;
   pragma Export (C, u00134, "switchB");
   u00135 : constant Version_32 := 16#3579e846#;
   pragma Export (C, u00135, "switchS");

   --  BEGIN ELABORATION ORDER
   --  ada%s
   --  interfaces%s
   --  system%s
   --  system.address_operations%s
   --  system.address_operations%b
   --  system.atomic_operations%s
   --  system.parameters%s
   --  system.parameters%b
   --  system.crtl%s
   --  interfaces.c_streams%s
   --  interfaces.c_streams%b
   --  system.storage_elements%s
   --  system.stack_checking%s
   --  system.stack_checking%b
   --  system.string_hash%s
   --  system.string_hash%b
   --  system.htable%s
   --  system.htable%b
   --  system.strings%s
   --  system.strings%b
   --  system.traceback_entries%s
   --  system.traceback_entries%b
   --  system.unsigned_types%s
   --  system.wch_con%s
   --  system.wch_con%b
   --  system.wch_jis%s
   --  system.wch_jis%b
   --  system.wch_cnv%s
   --  system.wch_cnv%b
   --  system.compare_array_unsigned_8%s
   --  system.compare_array_unsigned_8%b
   --  system.concat_2%s
   --  system.concat_2%b
   --  system.traceback%s
   --  system.traceback%b
   --  system.secondary_stack%s
   --  system.standard_library%s
   --  ada.exceptions%s
   --  system.exceptions_debug%s
   --  system.exceptions_debug%b
   --  system.soft_links%s
   --  system.wch_stw%s
   --  system.wch_stw%b
   --  ada.exceptions.last_chance_handler%s
   --  ada.exceptions.last_chance_handler%b
   --  ada.exceptions.traceback%s
   --  ada.exceptions.traceback%b
   --  system.address_image%s
   --  system.address_image%b
   --  system.exception_table%s
   --  system.exception_table%b
   --  ada.numerics%s
   --  ada.numerics.big_numbers%s
   --  system.exceptions%s
   --  system.exceptions.machine%s
   --  system.exceptions.machine%b
   --  system.img_int%s
   --  system.memory%s
   --  system.memory%b
   --  system.secondary_stack%b
   --  system.soft_links.initialize%s
   --  system.soft_links.initialize%b
   --  system.soft_links%b
   --  system.standard_library%b
   --  system.traceback.symbolic%s
   --  system.traceback.symbolic%b
   --  ada.exceptions%b
   --  ada.assertions%s
   --  ada.assertions%b
   --  ada.command_line%s
   --  ada.command_line%b
   --  gnat%s
   --  gnat.htable%s
   --  gnat.htable%b
   --  interfaces.c%s
   --  interfaces.c%b
   --  interfaces.c.strings%s
   --  interfaces.c.strings%b
   --  system.atomic_primitives%s
   --  system.atomic_primitives%b
   --  system.atomic_operations.test_and_set%s
   --  system.atomic_operations.test_and_set%b
   --  system.case_util%s
   --  system.case_util%b
   --  system.os_lib%s
   --  system.os_lib%b
   --  gnat.dynamic_htables%s
   --  gnat.dynamic_htables%b
   --  system.assertions%s
   --  system.assertions%b
   --  debug%s
   --  debug%b
   --  types%s
   --  types%b
   --  alloc%s
   --  gnatvsn%s
   --  gnatvsn%b
   --  hostparm%s
   --  indepsw%s
   --  indepsw%b
   --  opt%s
   --  csets%s
   --  csets%b
   --  opt%b
   --  output%s
   --  output%b
   --  rident%s
   --  table%s
   --  table%b
   --  widechar%s
   --  widechar%b
   --  namet%s
   --  namet%b
   --  butil%s
   --  butil%b
   --  casing%s
   --  casing%b
   --  fmap%s
   --  osint%s
   --  fmap%b
   --  sdefault%s
   --  sdefault%b
   --  targparm%s
   --  targparm%b
   --  osint%b
   --  fname%s
   --  fname%b
   --  snames%s
   --  snames%b
   --  ali%s
   --  ali%b
   --  switch%s
   --  switch%b
   --  gnatlink%s
   --  gnatlink%b
   --  END ELABORATION ORDER

end ada_main;
