/* do not edit automatically generated by mc from SymbolConversion.  */
/* SymbolConversion.def mapping between m2 symbols and gcc symbols.

Copyright (C) 2001-2024 Free Software Foundation, Inc.
Contributed by Gaius Mulley <gaius.mulley@southwales.ac.uk>.

This file is part of GNU Modula-2.

GNU Modula-2 is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

GNU Modula-2 is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Modula-2; see the file COPYING3.  If not see
<http://www.gnu.org/licenses/>.  */


#if !defined (_SymbolConversion_H)
#   define _SymbolConversion_H

#include "config.h"
#include "system.h"
#   ifdef __cplusplus
extern "C" {
#   endif
#include <stdbool.h>
#   if !defined (PROC_D)
#      define PROC_D
       typedef void (*PROC_t) (void);
       typedef struct { PROC_t proc; } PROC;
#   endif

#   include "Gm2tree.h"
#   include "GSYSTEM.h"

#   if defined (_SymbolConversion_C)
#      define EXTERN
#   else
#      define EXTERN extern
#   endif


/*
   Mod2Gcc - given a modula-2 symbol, sym, return the gcc equivalent.
*/

EXTERN m2tree_Tree SymbolConversion_Mod2Gcc (unsigned int sym);

/*
   Gcc2Mod - given a gcc tree return the modula-2 symbol.
*/

EXTERN unsigned int SymbolConversion_Gcc2Mod (m2tree_Tree tree);

/*
   AddModGcc - adds the tuple [ sym, gcc ] into the database.
*/

EXTERN void SymbolConversion_AddModGcc (unsigned int sym, m2tree_Tree gcc);

/*
   RemoveMod2Gcc - removes the gcc symbol from the lookup table.
*/

EXTERN void SymbolConversion_RemoveMod2Gcc (unsigned int sym);

/*
   GccKnowsAbout - returns TRUE if gcc knows about the symbol, sym.
*/

EXTERN bool SymbolConversion_GccKnowsAbout (unsigned int sym);

/*
   AddTemporaryKnown - adds a temporary gcc symbol against the modula-2 sym.
*/

EXTERN void SymbolConversion_AddTemporaryKnown (unsigned int sym);

/*
   RemoveTemporaryKnown - removes the temporary symbol.
*/

EXTERN void SymbolConversion_RemoveTemporaryKnown (unsigned int sym);

/*
   Poison - poisons a symbol.
*/

EXTERN void SymbolConversion_Poison (unsigned int sym);
#   ifdef __cplusplus
}
#   endif

#   undef EXTERN
#endif
