/* do not edit automatically generated by mc from P2Build.  */
/* output from m2-2.bnf, automatically generated do not edit if these
   are the top two lines in the file.

Copyright (C) 2001-2024 Free Software Foundation, Inc.
Contributed by Gaius Mulley <gaius.mulley@southwales.ac.uk>.

This file is part of GNU Modula-2.

GNU Modula-2 is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

GNU Modula-2 is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Modula-2; see the file COPYING.  If not,
see <https://www.gnu.org/licenses/>.  */

#include "config.h"
#include "system.h"
#include <stdbool.h>
#   if !defined (PROC_D)
#      define PROC_D
       typedef void (*PROC_t) (void);
       typedef struct { PROC_t proc; } PROC;
#   endif

#   if !defined (TRUE)
#      define TRUE (1==1)
#   endif

#   if !defined (FALSE)
#      define FALSE (1==0)
#   endif

#define _P2Build_H
#define _P2Build_C

#   include "GM2LexBuf.h"
#   include "GM2MetaError.h"
#   include "GNameKey.h"
#   include "GM2Reserved.h"
#   include "GDynamicStrings.h"
#   include "GM2Printf.h"
#   include "GM2Debug.h"
#   include "GM2Quads.h"
#   include "GP2SymBuild.h"
#   include "GSymbolTable.h"
#   include "GM2Error.h"

#   define Debugging false
#   define Pass1 false
#   define Pass2 true
#   define Pass3 false
typedef unsigned int P2Build_stop0;

typedef unsigned int P2Build_SetOfStop0;

typedef unsigned int P2Build_stop1;

typedef unsigned int P2Build_SetOfStop1;

typedef unsigned int P2Build_stop2;

typedef unsigned int P2Build_SetOfStop2;

static bool WasNoError;

/*
   CompilationUnit - returns TRUE if the input was correct enough to parse
                     in future passes.
*/

extern "C" bool P2Build_CompilationUnit (void);
static void ErrorString (DynamicStrings_String s);
static void ErrorArray (const char *a_, unsigned int _a_high);

/*
   DescribeStop - issues a message explaining what tokens were expected
*/

static DynamicStrings_String DescribeStop (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   DescribeError - issues a message explaining what tokens were expected
*/

static void DescribeError (void);

/*
   checkReturnAttribute -
*/

static void checkReturnAttribute (void);

/*
   checkParameterAttribute -
*/

static void checkParameterAttribute (void);

/*
   SyntaxError - after a syntax error we skip all tokens up until we reach
                 a stop symbol.
*/

static void SyntaxError (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   SyntaxCheck -
*/

static void SyntaxCheck (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   WarnMissingToken - generates a warning message about a missing token, t.
*/

static void WarnMissingToken (M2Reserved_toktype t);

/*
   MissingToken - generates a warning message about a missing token, t.
*/

static void MissingToken (M2Reserved_toktype t);

/*
   CheckAndInsert -
*/

static bool CheckAndInsert (M2Reserved_toktype t, P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   InStopSet
*/

static bool InStopSet (M2Reserved_toktype t, P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   PeepToken - peep token checks to see whether the stopset is satisfied by currenttoken
               If it is not then it will insert a token providing the token
               is one of ; ] ) } . OF END ,

               if the stopset contains <identtok> then we do not insert a token
*/

static void PeepToken (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Expect -
*/

static void Expect (M2Reserved_toktype t, P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Ident - error checking varient of Ident
*/

static void Ident (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   string -
*/

static void string (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Integer -
*/

static void Integer (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Real -
*/

static void Real (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   FileUnit := 
               % PushAutoOn  %
               ( DefinitionModule  | 
                 ImplementationOrProgramModule  ) 
               % PopAuto  %
               

   first  symbols:implementationtok, moduletok, definitiontok
   
   cannot reachend
*/

static void FileUnit (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ProgramModule := 'MODULE' 
                    % M2Error.DefaultProgramModule  %
                    
                    % BlockStart (GetTokenNo () -1)  %
                    Ident 
                    % P2StartBuildProgramModule ;  %
                    [ Priority  ] ';' { Import 
                                        % BuildImportOuterModule ;  %
                                         } Block 
                    % BlockEnd (GetTokenNo () -1)  %
                    Ident 
                    % P2EndBuildProgramModule ;  %
                    '.' 

   first  symbols:moduletok
   
   cannot reachend
*/

static void ProgramModule (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ImplementationModule := 'IMPLEMENTATION' 
                           % M2Error.DefaultImplementationModule  %
                           
                           % BlockStart (GetTokenNo () -1)  %
                           'MODULE' Ident 
                           % P2StartBuildImplementationModule ;  %
                           [ Priority  ] ';' { Import 
                                               
                                               % BuildImportOuterModule  %
                                                } Block 
                           
                           % BlockEnd (GetTokenNo () -1)  %
                           Ident 
                           % P2EndBuildImplementationModule ;  %
                           '.' 

   first  symbols:implementationtok
   
   cannot reachend
*/

static void ImplementationModule (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ImplementationOrProgramModule := ImplementationModule  | 
                                    ProgramModule 

   first  symbols:moduletok, implementationtok
   
   cannot reachend
*/

static void ImplementationOrProgramModule (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Number := Integer  | Real 

   first  symbols:realtok, integertok
   
   cannot reachend
*/

static void Number (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Qualident := 
                % VAR name: Name ;
                      Type, Sym, tok: CARDINAL ;  %
                Ident 
                % IF IsAutoPushOn()
                  THEN
                     PopTtok(name, tok) ;
                     Sym := RequestSym (tok, name) ;
                     IF IsDefImp(Sym) OR IsModule(Sym)
                     THEN
                        Expect(periodtok, stopset0, stopset1, stopset2 + SetOfStop2{identtok}) ;
                        StartScope(Sym) ;
                        Qualident(stopset0, stopset1, stopset2) ;
                         should we test for lack of ident? 
                        PopTFtok(Sym, Type, tok) ;
                        PushTFtok(Sym, Type, tok) ;
                        Annotate("%1s(%1d)|%1s(%1d)||qualident|type") ;
                        EndScope ;
                        PutIncluded(Sym)
                     ELSE
                        PushTFtok(Sym, GetType(Sym), tok) ;
                        Annotate("%1s(%1d)|%1s(%1d)||qualident|type")
                     END
                  ELSE  just parse qualident   %
                { '.' Ident  } 
                % END  %
                

   first  symbols:identtok
   
   cannot reachend
*/

static void Qualident (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ConstantDeclaration := Ident '=' 
                          % SeenUnknown ;
                            BuildConst  %
                          ConstExpressionInitial 
                          % DetermineType ;
                            PopNothing  %
                          

   first  symbols:identtok
   
   cannot reachend
*/

static void ConstantDeclaration (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ConstExpressionInitial := 
                             % PushAutoOff  %
                             SimpleConstExpr [ Relation 
                                               SimpleConstExpr  ] 
                             
                             % PopAuto  %
                             

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void ConstExpressionInitial (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ConstExpression := 
                      % PushType ; SeenUnknown ; PushAutoOff  %
                      SimpleConstExpr [ Relation SimpleConstExpr  ] 
                      
                      % PopAuto ; PopType  %
                      

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void ConstExpression (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Relation := 
               % SeenUnknown  actually it will be a BOOLEAN, but this is not a constructor and not a string   %
               '='  | '#'  | '<>'  | '<'  | '<='  | 
               '>'  | '>='  | 'IN' 

   first  symbols:intok, greaterequaltok, greatertok, lessequaltok, lesstok, lessgreatertok, hashtok, equaltok
   
   cannot reachend
*/

static void Relation (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   SimpleConstExpr := UnaryOrConstTerm { AddOperator 
                                         ConstTerm  } 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void SimpleConstExpr (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   UnaryOrConstTerm := '+' ConstTerm  | 
                       '-' ConstTerm  | 
                       ConstTerm 

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void UnaryOrConstTerm (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   AddOperator := '+'  | '-'  | 'OR' 
                  % SeenUnknown  actually it will be a BOOLEAN, but this is not a constructor and not a string   %
                  

   first  symbols:ortok, minustok, plustok
   
   cannot reachend
*/

static void AddOperator (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ConstTerm := ConstFactor { MulOperator ConstFactor  } 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok
   
   cannot reachend
*/

static void ConstTerm (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   MulOperator := '*'  | '/'  | 'DIV' 
                  % SeenUnknown  %
                   | 'MOD' 
                  % SeenUnknown  %
                   | 'REM' 
                  % SeenUnknown  %
                   | 'AND' 
                  % SeenUnknown  %
                   | '&' 
                  % SeenUnknown  %
                  

   first  symbols:ambersandtok, andtok, remtok, modtok, divtok, dividetok, timestok
   
   cannot reachend
*/

static void MulOperator (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ConstFactor := Number  | ConstString  | 
                  ConstSetOrQualidentOrFunction  | 
                  '(' ConstExpression ')'  | 
                  'NOT' ConstFactor  | 
                  ConstAttribute 

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok
   
   cannot reachend
*/

static void ConstFactor (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ConstString := string 
                  % SeenString  %
                  

   first  symbols:stringtok
   
   cannot reachend
*/

static void ConstString (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ComponentElement := ConstExpression [ '..' 
                                         % PopType ; SeenSet ; PushType ; SeenUnknown  %
                                         ConstExpression  ] 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void ComponentElement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ComponentValue := 
                     % PushType ; SeenUnknown ; PushRememberConstant  %
                     ComponentElement [ 'BY' 
                                        % PopType ; SeenArray ; PushType ; SeenUnknown  %
                                        ConstExpression  ] 
                     
                     % PopType  double check position, it must balance PushType   %
                     
                     % PopRememberConstant  %
                     

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void ComponentValue (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ArraySetRecordValue := ComponentValue { ',' ComponentValue  } 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void ArraySetRecordValue (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Constructor := '{' 
                  % SeenConstructor  %
                  [ ArraySetRecordValue  ] '}' 

   first  symbols:lcbratok
   
   cannot reachend
*/

static void Constructor (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ConstSetOrQualidentOrFunction := Constructor  | 
                                    Qualident [ Constructor  | 
                                                ConstActualParameters  ] 

   first  symbols:identtok, lcbratok
   
   cannot reachend
*/

static void ConstSetOrQualidentOrFunction (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ConstActualParameters := 
                            % PushType ; SeenUnknown  %
                            '(' [ ExpList  ] ')' 
                            % PopType  %
                            

   first  symbols:lparatok
   
   cannot reachend
*/

static void ConstActualParameters (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ConstAttribute := '__ATTRIBUTE__' '__BUILTIN__' 
                     '(' '(' ConstAttributeExpression 
                     ')' ')' 

   first  symbols:attributetok
   
   cannot reachend
*/

static void ConstAttribute (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ConstAttributeExpression := Ident  | '<' Qualident 
                               ',' Ident '>' 

   first  symbols:lesstok, identtok
   
   cannot reachend
*/

static void ConstAttributeExpression (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ByteAlignment := '' 

   first  symbols:ldirectivetok
   
   cannot reachend
*/

static void ByteAlignment (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Alignment := ByteAlignment  | 
                % PushT(NulSym)  %
                

   first  symbols:ldirectivetok
   
   reachend
*/

static void Alignment (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   TypeDeclaration := 
                      % VAR top: CARDINAL ;  %
                      
                      % top := Top()  %
                      Ident '=' Type Alignment 
                      % BuildTypeAlignment  %
                      
                      % Assert(top=Top())  %
                      

   first  symbols:identtok
   
   cannot reachend
*/

static void TypeDeclaration (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Type := 
           % PushAutoOn ;  %
           ( SimpleType  | ArrayType 
             % BuildType ;  %
              | RecordType 
             % BuildType ;  %
              | SetType 
             % BuildType ;  %
              | PointerType 
             % BuildType ;  %
              | ProcedureType 
             % BuildType ;  %
              ) 
           % PopAuto ;  %
           

   first  symbols:lparatok, lsbratok, proceduretok, pointertok, settok, packedsettok, oftok, recordtok, arraytok, identtok
   
   cannot reachend
*/

static void Type (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   SimpleType := ( Qualident [ PrefixedSubrangeType  ] 
                   
                   % BuildType ;  %
                    | 
                   Enumeration 
                   % BuildType ;  %
                    | SubrangeType 
                   % BuildType ;  %
                    ) 

   first  symbols:lsbratok, lparatok, identtok
   
   cannot reachend
*/

static void SimpleType (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Enumeration := '(' ( IdentList  ) ')' 
                  % StartBuildEnumeration ;  %
                  

   first  symbols:lparatok
   
   cannot reachend
*/

static void Enumeration (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   IdentList := Ident 
                % VAR
                                                                                                  on: BOOLEAN ;
                                                                                                  n : CARDINAL ;  %
                
                % on := IsAutoPushOn() ;
                  IF on
                  THEN
                     n := 1
                  END  %
                { ',' Ident 
                  % IF on
                    THEN
                       INC(n)
                    END  %
                   } 
                % IF on
                  THEN
                     PushT(n)
                  END  %
                

   first  symbols:identtok
   
   cannot reachend
*/

static void IdentList (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   SubrangeType := '[' ConstExpression '..' ConstExpression 
                   ']' 
                   % BuildSubrange(NulSym)  %
                   

   first  symbols:lsbratok
   
   cannot reachend
*/

static void SubrangeType (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   PrefixedSubrangeType := '[' ConstExpression '..' 
                           ConstExpression ']' 
                           % VAR t: CARDINAL ;  %
                           
                           % PopT(t) ;
                             BuildSubrange(t)  %
                           

   first  symbols:lsbratok
   
   cannot reachend
*/

static void PrefixedSubrangeType (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ArrayType := 'ARRAY' 
                % VAR arrayType, tok: CARDINAL ;  %
                
                % StartBuildArray ;
                  PopTtok(arrayType, tok) ;
                  PushTtok(arrayType, tok) ;
                  BuildNulName ;  %
                SimpleType 
                % BuildFieldArray ;  %
                { ',' 
                  % BuildArrayComma ;
                    BuildNulName ;  %
                  SimpleType 
                  % BuildFieldArray ;  %
                   } 'OF' 
                % BuildNulName ;  %
                Type 
                % EndBuildArray ;
                  PopNothing ;
                  PushTtok(arrayType, tok)  %
                

   first  symbols:arraytok
   
   cannot reachend
*/

static void ArrayType (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   RecordType := 'RECORD' 
                 % BuildRecord  %
                 [ DefaultRecordAttributes  ] FieldListSequence 
                 'END' 

   first  symbols:recordtok
   
   cannot reachend
*/

static void RecordType (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   DefaultRecordAttributes := '' 

   first  symbols:ldirectivetok
   
   cannot reachend
*/

static void DefaultRecordAttributes (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   RecordFieldPragma := ( ''  | 
                          
                          % n := 0  %
                          
                          % PushT(n)  %
                          
                          % Annotate('(%1d)||pragma count')  %
                           ) 

   first  symbols:ldirectivetok
   
   reachend
*/

static void RecordFieldPragma (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   FieldPragmaExpression := 
                            % PushAutoOn  %
                            Ident PragmaConstExpression 
                            
                            % PopAuto  %
                            

   first  symbols:identtok
   
   cannot reachend
*/

static void FieldPragmaExpression (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   PragmaConstExpression := ( 
                              % PushAutoOff  %
                              '(' ConstExpression 
                              % BuildPragmaConst  %
                              ')' 
                              % PopAuto  %
                               | 
                              
                              % PushT(NulSym)  %
                              
                              % Annotate('NulSym||no pragma const')  %
                               ) 

   first  symbols:lparatok
   
   reachend
*/

static void PragmaConstExpression (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   AttributeExpression := Ident '(' ConstExpression 
                          ')' 

   first  symbols:identtok
   
   cannot reachend
*/

static void AttributeExpression (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   FieldListSequence := FieldListStatement { ';' FieldListStatement  } 

   first  symbols:casetok, identtok, semicolontok
   
   reachend
*/

static void FieldListSequence (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   FieldListStatement := [ FieldList  ] 

   first  symbols:identtok, casetok
   
   reachend
*/

static void FieldListStatement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   FieldList := IdentList ':' 
                % BuildNulName  %
                Type RecordFieldPragma 
                % BuildFieldRecord  %
                 | 
                'CASE' 
                % AddRecordToList  %
                
                % StartBuildVarient  %
                
                % AddVarientToList  %
                CaseTag 'OF' Varient { '|' Varient  } 
                [ 'ELSE' 
                  % StartBuildVarientFieldRecord  %
                  FieldListSequence 
                  % EndBuildVarientFieldRecord  %
                   ] 'END' 
                % EndBuildVarient  %
                

   first  symbols:casetok, identtok
   
   cannot reachend
*/

static void FieldList (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   TagIdent := Ident  | 
               % BuildNulName  %
               

   first  symbols:identtok
   
   reachend
*/

static void TagIdent (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   CaseTag := TagIdent ( ':' Qualident  | 
                         
                         % PushT(NulSym)  %
                          ) 
              % BuildVarientSelector  %
              

   first  symbols:colontok, identtok
   
   reachend
*/

static void CaseTag (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Varient := [ 
                % StartBuildVarientFieldRecord  %
                VarientCaseLabelList ':' FieldListSequence 
                
                % EndBuildVarientFieldRecord  %
                 ] 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   reachend
*/

static void Varient (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   VarientCaseLabelList := VarientCaseLabels { ',' 
                                               VarientCaseLabels  } 

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void VarientCaseLabelList (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   VarientCaseLabels := ConstExpression [ '..' ConstExpression  ] 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void VarientCaseLabels (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   CaseLabelList := CaseLabels { ',' CaseLabels  } 

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void CaseLabelList (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   CaseLabels := ConstExpression [ '..' ConstExpression  ] 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void CaseLabels (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   SetType := 
              % VAR ispacked: BOOLEAN ;
                    setpos  : CARDINAL ;  %
              
              % setpos := GetTokenNo ()  %
              
              % ispacked := FALSE  %
              ( 'SET' 
                % ispacked := FALSE  %
                 | 'PACKEDSET' 
                % ispacked := TRUE  %
                 ) 'OF' 
              % BuildNulName  %
              SimpleType 
              % BuildSetType (setpos, ispacked)  %
              

   first  symbols:oftok, packedsettok, settok
   
   cannot reachend
*/

static void SetType (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   PointerType := 
                  % VAR pointerpos: CARDINAL ;  %
                  
                  % pointerpos := GetTokenNo ()  %
                  'POINTER' 'TO' 
                  % BuildNulName  %
                  Type 
                  % BuildPointerType (pointerpos)  %
                  

   first  symbols:pointertok
   
   cannot reachend
*/

static void PointerType (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ProcedureType := 'PROCEDURE' 
                    % BuildProcedureType ;  %
                    [ FormalTypeList  ] 

   first  symbols:proceduretok
   
   cannot reachend
*/

static void ProcedureType (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   FormalTypeList := '(' ( ')' FormalReturn  | 
                           ProcedureParameters ')' 
                           FormalReturn  ) 

   first  symbols:lparatok
   
   cannot reachend
*/

static void FormalTypeList (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   FormalReturn := [ ':' OptReturnType  ] 

   first  symbols:colontok
   
   reachend
*/

static void FormalReturn (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   OptReturnType := '[' Qualident 
                    % BuildOptFunction  %
                    ']'  | Qualident 
                    % BuildFunction  %
                    

   first  symbols:identtok, lsbratok
   
   cannot reachend
*/

static void OptReturnType (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ProcedureParameters := ProcedureParameter { ',' 
                                               ProcedureParameter  } 

   first  symbols:identtok, arraytok, periodperiodperiodtok, vartok
   
   cannot reachend
*/

static void ProcedureParameters (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ProcedureParameter := '...' 
                         % BuildFormalVarArgs  %
                          | 'VAR' 
                         % PushT(VarTok) ;  %
                         FormalType 
                         % BuildFormalType ;  %
                          | 
                         % PushT(NulTok) ;  %
                         FormalType 
                         % BuildFormalType ;  %
                         

   first  symbols:arraytok, identtok, vartok, periodperiodperiodtok
   
   cannot reachend
*/

static void ProcedureParameter (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   VarIdent := Ident 
               % VAR
                                                                                                 on            : BOOLEAN ;
                                                                                                 Sym, Type, tok: CARDINAL ;  %
               [ '[' 
                 % on := IsAutoPushOn() ;
                   IF on
                   THEN
                      PopTFtok(Sym, Type, tok) ;
                      PushTFAtok(Sym, Type, Sym, tok)
                   END  %
                 ConstExpression ']'  ] 

   first  symbols:identtok
   
   cannot reachend
*/

static void VarIdent (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   VarIdentList := VarIdent 
                   % VAR
                                                                                                     on: BOOLEAN ;
                                                                                                     n : CARDINAL ;  %
                   
                   % on := IsAutoPushOn() ;
                     IF on
                     THEN
                        n := 1
                     END  %
                   { ',' VarIdent 
                     % IF on
                       THEN
                          INC(n)
                       END  %
                      } 
                   % IF on
                     THEN
                        PushT(n)
                     END  %
                   

   first  symbols:identtok
   
   cannot reachend
*/

static void VarIdentList (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   VariableDeclaration := VarIdentList ':' 
                          % BuildNulName  %
                          
                          % DisplayStack  %
                          Type 
                          % DisplayStack  %
                          Alignment 
                          % DisplayStack  %
                          
                          % BuildVarAlignment  %
                          
                          % DisplayStack  %
                          
                          % BuildVariable  %
                          

   first  symbols:identtok
   
   cannot reachend
*/

static void VariableDeclaration (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Designator := Qualident { SubDesignator  } 

   first  symbols:identtok
   
   cannot reachend
*/

static void Designator (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   SubDesignator := '.' Ident  | '[' ExpList ']'  | 
                    '^' 

   first  symbols:uparrowtok, lsbratok, periodtok
   
   cannot reachend
*/

static void SubDesignator (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ExpList := Expression { ',' Expression  } 

   first  symbols:lcbratok, identtok, realtok, integertok, stringtok, lparatok, nottok, attributetok, plustok, minustok
   
   cannot reachend
*/

static void ExpList (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Expression := 
                 % PushType ; SeenUnknown ; PushAutoOff  %
                 SimpleExpression [ Relation SimpleExpression  ] 
                 
                 % PopAuto ; PopType  %
                 

   first  symbols:identtok, lcbratok, attributetok, nottok, lparatok, stringtok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void Expression (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   SimpleExpression := UnaryOrTerm { AddOperator Term  } 

   first  symbols:lcbratok, identtok, realtok, integertok, stringtok, lparatok, nottok, attributetok, plustok, minustok
   
   cannot reachend
*/

static void SimpleExpression (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   UnaryOrTerm := '+' Term  | '-' Term  | 
                  Term 

   first  symbols:identtok, lcbratok, attributetok, nottok, lparatok, stringtok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void UnaryOrTerm (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Term := Factor { MulOperator Factor  } 

   first  symbols:lcbratok, identtok, realtok, integertok, stringtok, lparatok, nottok, attributetok
   
   cannot reachend
*/

static void Term (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Factor := Number  | string  | SetOrDesignatorOrFunction  | 
             '(' Expression ')'  | 
             'NOT' Factor  | ConstAttribute 

   first  symbols:identtok, lcbratok, attributetok, nottok, lparatok, stringtok, integertok, realtok
   
   cannot reachend
*/

static void Factor (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   SetOrDesignatorOrFunction := ( Qualident [ Constructor  | 
                                              SimpleDes 
                                              [ ActualParameters  ]  ]  | 
                                  Constructor  ) 

   first  symbols:lcbratok, identtok
   
   cannot reachend
*/

static void SetOrDesignatorOrFunction (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   SimpleDes := { '.' Ident  | '[' ExpList ']'  | 
                  '^'  } 

   first  symbols:uparrowtok, lsbratok, periodtok
   
   reachend
*/

static void SimpleDes (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ActualParameters := '(' [ ExpList  ] ')' 

   first  symbols:lparatok
   
   cannot reachend
*/

static void ActualParameters (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Statement := 
                % PushAutoOff ;  %
                [ AssignmentOrProcedureCall  | 
                  IfStatement  | CaseStatement  | 
                  WhileStatement  | 
                  RepeatStatement  | 
                  LoopStatement  | ForStatement  | 
                  WithStatement  | AsmStatement  | 
                  'EXIT'  | 'RETURN' [ Expression  ]  | 
                  RetryStatement  ] 
                % PopAuto ;  %
                

   first  symbols:retrytok, asmtok, withtok, fortok, looptok, repeattok, whiletok, casetok, iftok, identtok, returntok, exittok
   
   reachend
*/

static void Statement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   RetryStatement := 'RETRY' 

   first  symbols:retrytok
   
   cannot reachend
*/

static void RetryStatement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   AssignmentOrProcedureCall := Designator ( ':=' Expression  | 
                                             ActualParameters  | 
                                             
                                             %  epsilon   %
                                              ) 

   first  symbols:identtok
   
   cannot reachend
*/

static void AssignmentOrProcedureCall (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   StatementSequence := Statement { ';' Statement  } 

   first  symbols:identtok, iftok, casetok, whiletok, repeattok, looptok, fortok, withtok, asmtok, retrytok, semicolontok, exittok, returntok
   
   reachend
*/

static void StatementSequence (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   IfStatement := 'IF' Expression 'THEN' StatementSequence 
                  { 'ELSIF' Expression 'THEN' StatementSequence  } 
                  [ 'ELSE' StatementSequence  ] 'END' 

   first  symbols:iftok
   
   cannot reachend
*/

static void IfStatement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   CaseStatement := 'CASE' Expression 'OF' Case { '|' 
                                                  Case  } 
                    [ 'ELSE' StatementSequence  ] 'END' 

   first  symbols:casetok
   
   cannot reachend
*/

static void CaseStatement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Case := [ CaseLabelList ':' StatementSequence  ] 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   reachend
*/

static void Case (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   WhileStatement := 'WHILE' Expression 'DO' StatementSequence 
                     'END' 

   first  symbols:whiletok
   
   cannot reachend
*/

static void WhileStatement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   RepeatStatement := 'REPEAT' StatementSequence 'UNTIL' 
                      Expression 

   first  symbols:repeattok
   
   cannot reachend
*/

static void RepeatStatement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ForStatement := 'FOR' Ident ':=' Expression 'TO' 
                   Expression [ 'BY' ConstExpression  ] 
                   'DO' StatementSequence 'END' 

   first  symbols:fortok
   
   cannot reachend
*/

static void ForStatement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   LoopStatement := 'LOOP' StatementSequence 'END' 

   first  symbols:looptok
   
   cannot reachend
*/

static void LoopStatement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   WithStatement := 'WITH' Designator 'DO' StatementSequence 
                    'END' 

   first  symbols:withtok
   
   cannot reachend
*/

static void WithStatement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ProcedureDeclaration := ProcedureHeading 
                           % Assert(IsProcedure(OperandT(1)))  %
                           ';' ( ProcedureBlock 
                                 % Assert(IsProcedure(OperandT(1)))  %
                                 Ident  ) 
                           % EndBuildProcedure  %
                           

   first  symbols:proceduretok
   
   cannot reachend
*/

static void ProcedureDeclaration (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   DefineBuiltinProcedure := [ '__ATTRIBUTE__' '__BUILTIN__' 
                               '(' '(' 
                               % PushAutoOff  %
                               Ident 
                               % PopAuto  %
                               ')' ')'  | 
                               '__INLINE__'  ] 

   first  symbols:inlinetok, attributetok
   
   reachend
*/

static void DefineBuiltinProcedure (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ProcedureHeading := 'PROCEDURE' 
                       % M2Error.DefaultProcedure  %
                       DefineBuiltinProcedure ( Ident 
                                                
                                                % StartBuildProcedure  %
                                                
                                                % Assert(IsProcedure(OperandT(1)))  %
                                                
                                                % StartBuildFormalParameters   %
                                                [ FormalParameters  ] 
                                                
                                                % EndBuildFormalParameters  %
                                                AttributeNoReturn 
                                                
                                                % BuildProcedureHeading  %
                                                 ) 

   first  symbols:proceduretok
   
   cannot reachend
*/

static void ProcedureHeading (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Builtin := [ '__BUILTIN__'  | '__INLINE__'  ] 

   first  symbols:inlinetok, builtintok
   
   reachend
*/

static void Builtin (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   DefProcedureHeading := 'PROCEDURE' 
                          % M2Error.DefaultProcedure  %
                          Builtin ( Ident 
                                    % StartBuildProcedure  %
                                    
                                    % Assert(IsProcedure(OperandT(1)))  %
                                    
                                    % StartBuildFormalParameters   %
                                    [ DefFormalParameters  ] 
                                    
                                    % EndBuildFormalParameters  %
                                    AttributeNoReturn 
                                    
                                    % BuildProcedureHeading  %
                                     ) 
                          % M2Error.LeaveErrorScope  %
                          

   first  symbols:proceduretok
   
   cannot reachend
*/

static void DefProcedureHeading (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   AttributeNoReturn := [ ''  ] 

   first  symbols:ldirectivetok
   
   reachend
*/

static void AttributeNoReturn (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   AttributeUnused := [ ''  ] 

   first  symbols:ldirectivetok
   
   reachend
*/

static void AttributeUnused (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ProcedureBlock := 
                     % Assert(IsProcedure(OperandT(1)))  %
                     { 
                       % Assert(IsProcedure(OperandT(1)))  %
                       Declaration 
                       % Assert(IsProcedure(OperandT(1)))  %
                        } [ 'BEGIN' ProcedureBlockBody  ] 
                     'END' 
                     % Assert(IsProcedure(OperandT(1)))  %
                     

   first  symbols:proceduretok, moduletok, consttok, typetok, vartok, endtok, begintok
   
   cannot reachend
*/

static void ProcedureBlock (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Block := { Declaration  } InitialBlock FinalBlock 
            'END' 

   first  symbols:proceduretok, moduletok, finallytok, begintok, consttok, typetok, vartok, endtok
   
   cannot reachend
*/

static void Block (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   InitialBlock := [ 'BEGIN' 
                     % BlockBegin (GetTokenNo () -1)  %
                     InitialBlockBody  ] 

   first  symbols:begintok
   
   reachend
*/

static void InitialBlock (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   FinalBlock := [ 'FINALLY' 
                   % BlockFinally (GetTokenNo () -1)  %
                   FinalBlockBody  ] 

   first  symbols:finallytok
   
   reachend
*/

static void FinalBlock (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   InitialBlockBody := NormalPart [ 'EXCEPT' 
                                    % PutExceptionBlock(GetCurrentScope())  %
                                    ExceptionalPart  ] 

   first  symbols:identtok, iftok, casetok, whiletok, repeattok, looptok, fortok, withtok, asmtok, retrytok, semicolontok, exittok, returntok, excepttok
   
   reachend
*/

static void InitialBlockBody (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   FinalBlockBody := NormalPart [ 'EXCEPT' 
                                  % PutExceptionFinally(GetCurrentScope())  %
                                  ExceptionalPart  ] 

   first  symbols:identtok, iftok, casetok, whiletok, repeattok, looptok, fortok, withtok, asmtok, retrytok, semicolontok, exittok, returntok, excepttok
   
   reachend
*/

static void FinalBlockBody (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ProcedureBlockBody := NormalPart [ 'EXCEPT' 
                                      % PutExceptionBlock(GetCurrentScope())  %
                                      ExceptionalPart  ] 

   first  symbols:identtok, iftok, casetok, whiletok, repeattok, looptok, fortok, withtok, asmtok, retrytok, semicolontok, exittok, returntok, excepttok
   
   reachend
*/

static void ProcedureBlockBody (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   NormalPart := StatementSequence 

   first  symbols:retrytok, asmtok, withtok, fortok, looptok, repeattok, whiletok, casetok, iftok, identtok, returntok, exittok, semicolontok
   
   reachend
*/

static void NormalPart (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ExceptionalPart := StatementSequence 

   first  symbols:retrytok, asmtok, withtok, fortok, looptok, repeattok, whiletok, casetok, iftok, identtok, returntok, exittok, semicolontok
   
   reachend
*/

static void ExceptionalPart (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Declaration := 'CONST' { ConstantDeclaration ';'  }  | 
                  'TYPE' { TypeDeclaration ';'  }  | 
                  'VAR' { VariableDeclaration ';'  }  | 
                  ProcedureDeclaration ';'  | 
                  ModuleDeclaration ';' 

   first  symbols:moduletok, proceduretok, vartok, typetok, consttok
   
   cannot reachend
*/

static void Declaration (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   DefFormalParameters := '(' [ DefMultiFPSection  ] 
                          
                          % VAR n: CARDINAL;  %
                          
                          % PopT(n) ;  remove param count   %
                          ')' FormalReturn 
                          % PushT(n) ;  restore param count   %
                          

   first  symbols:lparatok
   
   cannot reachend
*/

static void DefFormalParameters (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   DefMultiFPSection := DefExtendedFP  | 
                        FPSection [ ';' DefMultiFPSection  ] 

   first  symbols:identtok, vartok, lsbratok, periodperiodperiodtok
   
   cannot reachend
*/

static void DefMultiFPSection (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   FormalParameters := '(' [ MultiFPSection  ] 
                       % VAR n: CARDINAL;  %
                       
                       % PopT(n) ;  remove param count   %
                       ')' FormalReturn 
                       % PushT(n) ;  restore param count   %
                       

   first  symbols:lparatok
   
   cannot reachend
*/

static void FormalParameters (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   MultiFPSection := ExtendedFP  | FPSection [ ';' 
                                               MultiFPSection  ] 

   first  symbols:identtok, vartok, lsbratok, periodperiodperiodtok
   
   cannot reachend
*/

static void MultiFPSection (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   FPSection := NonVarFPSection  | 
                VarFPSection 

   first  symbols:vartok, identtok
   
   cannot reachend
*/

static void FPSection (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   DefExtendedFP := DefOptArg  | '...' 
                    % BuildVarArgs  %
                    

   first  symbols:lsbratok, periodperiodperiodtok
   
   cannot reachend
*/

static void DefExtendedFP (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ExtendedFP := OptArg  | '...' 
                 % BuildVarArgs  %
                 

   first  symbols:lsbratok, periodperiodperiodtok
   
   cannot reachend
*/

static void ExtendedFP (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   OptArg := '[' 
             % VAR n: CARDINAL ;  %
             
             % PopT(n)  %
             
             % PushT(NulTok)  %
             Ident 
             % PushT(1)  %
             ':' FormalType 
             % PushT(n)  %
             
             % BuildFPSection  %
             
             % BuildOptArg  %
             [ '=' ConstExpression  ] ']' 

   first  symbols:lsbratok
   
   cannot reachend
*/

static void OptArg (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   DefOptArg := '[' 
                % VAR n: CARDINAL ;  %
                
                % PopT(n)  %
                
                % PushT(NulTok)  %
                Ident 
                % PushT(1)  %
                ':' FormalType 
                % PushT(n)  %
                
                % BuildFPSection  %
                
                % BuildOptArg  %
                '=' ConstExpression ']' 

   first  symbols:lsbratok
   
   cannot reachend
*/

static void DefOptArg (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   VarFPSection := 'VAR' 
                   % VAR n: CARDINAL ;  %
                   
                   % PopT(n) ;  %
                   
                   % PushT(VarTok) ;  %
                   IdentList ':' FormalType 
                   % PushT(n)  %
                   [ AttributeUnused  ] 
                   % BuildFPSection  %
                   

   first  symbols:vartok
   
   cannot reachend
*/

static void VarFPSection (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   NonVarFPSection := 
                      % VAR n: CARDINAL ;  %
                      
                      % PopT(n)  %
                      
                      % PushT(NulTok)  %
                      IdentList ':' FormalType 
                      % PushT(n)  %
                      [ AttributeUnused  ] 
                      % BuildFPSection  %
                      

   first  symbols:identtok
   
   cannot reachend
*/

static void NonVarFPSection (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   FormalType := 'ARRAY' 'OF' 
                 % VAR n: CARDINAL ;  %
                 
                 % PushTF(ArrayTok, 1)  %
                 { 'ARRAY' 'OF' 
                   % PopTF(ArrayTok, n)  %
                   
                   % INC(n)  %
                   
                   % PushTF(ArrayTok, n)  %
                    } Qualident  | 
                 
                 % VAR Sym, Type: CARDINAL ;  %
                 Qualident 
                 % PopTF(Sym, Type) ;
                   PushT(NulTok) ;
                   PushTF(Sym, Type)  %
                 

   first  symbols:identtok, arraytok
   
   cannot reachend
*/

static void FormalType (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   ModuleDeclaration := 'MODULE' 
                        % M2Error.DefaultInnerModule  %
                        
                        % BlockStart (GetTokenNo () -1)  %
                        Ident 
                        % StartBuildInnerModule  %
                        [ Priority  ] ';' { Import 
                                            
                                            % BuildImportInnerModule  %
                                             } [ Export 
                                                 
                                                 % BuildExportInnerModule  %
                                                  ] 
                        Block 
                        % BlockEnd (GetTokenNo () -1)  %
                        Ident 
                        % EndBuildInnerModule  %
                        

   first  symbols:moduletok
   
   cannot reachend
*/

static void ModuleDeclaration (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Priority := '[' ConstExpression ']' 

   first  symbols:lsbratok
   
   cannot reachend
*/

static void Priority (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Export := 'EXPORT' ( 'QUALIFIED' 
                        % PushT(QualifiedTok)  %
                        IdentList  | 
                        'UNQUALIFIED' 
                        % PushT(UnQualifiedTok)  %
                        IdentList  | 
                        
                        % PushT(ExportTok)  %
                        IdentList  ) ';' 

   first  symbols:exporttok
   
   cannot reachend
*/

static void Export (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Import := 'FROM' Ident 'IMPORT' IdentList ';'  | 
             'IMPORT' 
             % PushT(ImportTok)
                                                                                             determines whether Ident or Module   %
             IdentList ';' 

   first  symbols:importtok, fromtok
   
   cannot reachend
*/

static void Import (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   DefinitionModule := 'DEFINITION' 
                       % M2Error.DefaultDefinitionModule  %
                       'MODULE' [ 'FOR' string  ] Ident 
                       
                       % P2StartBuildDefModule  %
                       ';' { Import 
                             % BuildImportOuterModule  %
                              } [ Export 
                                  % BuildExportOuterModule  %
                                   ] { Definition  } 
                       'END' Ident 
                       % P2EndBuildDefModule  %
                       '.' 

   first  symbols:definitiontok
   
   cannot reachend
*/

static void DefinitionModule (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   Definition := 'CONST' { ConstantDeclaration ';'  }  | 
                 'TYPE' { Ident ( ';'  | '=' Type Alignment 
                                  
                                  % BuildVarAlignment  %
                                  ';'  ) 
                          % BuildTypeEnd  %
                           }  | 
                 'VAR' { VariableDeclaration ';'  }  | 
                 DefProcedureHeading ';' 

   first  symbols:proceduretok, vartok, typetok, consttok
   
   cannot reachend
*/

static void Definition (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   AsmStatement := 'ASM' [ 'VOLATILE'  ] '(' AsmOperands 
                   ')' 

   first  symbols:asmtok
   
   cannot reachend
*/

static void AsmStatement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   NamedOperand := '[' Ident ']' 

   first  symbols:lsbratok
   
   cannot reachend
*/

static void NamedOperand (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   AsmOperandName := [ NamedOperand  ] 

   first  symbols:lsbratok
   
   reachend
*/

static void AsmOperandName (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   AsmOperands := ConstExpression ':' AsmList [ ':' 
                                                AsmList 
                                                [ ':' 
                                                  TrashList  ]  ] 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void AsmOperands (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   AsmList := [ AsmElement  ] { ',' AsmElement  } 

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok, lsbratok, commatok
   
   reachend
*/

static void AsmList (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   AsmElement := AsmOperandName ConstExpression '(' 
                 Expression ')' 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok, lsbratok
   
   cannot reachend
*/

static void AsmElement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

/*
   TrashList := [ ConstExpression  ] { ',' ConstExpression  } 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok, commatok
   
   reachend
*/

static void TrashList (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2);

static void ErrorString (DynamicStrings_String s)
{
  M2MetaError_MetaErrorStringT0 (M2LexBuf_GetTokenNo (), s);  /* permanently disabled for the time being  */
  WasNoError = false;
}

static void ErrorArray (const char *a_, unsigned int _a_high)
{
  char a[_a_high+1];

  /* make a local copy of each unbounded array.  */
  memcpy (a, a_, _a_high+1);

  ErrorString (DynamicStrings_InitString ((const char *) a, _a_high));
}


/*
   DescribeStop - issues a message explaining what tokens were expected
*/

static DynamicStrings_String DescribeStop (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  unsigned int n;
  DynamicStrings_String str;
  DynamicStrings_String message;

  n = 0;
  message = DynamicStrings_InitString ((const char *) "", 0);
  if ((((1 << (M2Reserved_stringtok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%Kstring}", 10)));
      n += 1;
    }
  if ((((1 << (M2Reserved_realtok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%Kreal number}", 15)));
      n += 1;
    }
  if ((((1 << (M2Reserved_identtok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%Kidentifier}", 14)));
      n += 1;
    }
  if ((((1 << (M2Reserved_integertok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%Kinteger number}", 18)));
      n += 1;
    }
  if ((((1 << (M2Reserved_inlinetok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K__INLINE__}", 14)));
      n += 1;
    }
  if ((((1 << (M2Reserved_builtintok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K__BUILTIN__}", 15)));
      n += 1;
    }
  if ((((1 << (M2Reserved_attributetok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K__ATTRIBUTE__}", 17)));
      n += 1;
    }
  if ((((1 << (M2Reserved_filetok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K__FILE__}", 12)));
      n += 1;
    }
  if ((((1 << (M2Reserved_linetok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K__LINE__}", 12)));
      n += 1;
    }
  if ((((1 << (M2Reserved_datetok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K__DATE__}", 12)));
      n += 1;
    }
  if ((((1 << (M2Reserved_periodperiodperiodtok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K...}", 7)));
      n += 1;
    }
  if ((((1 << (M2Reserved_volatiletok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KVOLATILE}", 12)));
      n += 1;
    }
  if ((((1 << (M2Reserved_asmtok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KASM}", 7)));
      n += 1;
    }
  if ((((1 << (M2Reserved_withtok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KWITH}", 8)));
      n += 1;
    }
  if ((((1 << (M2Reserved_whiletok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KWHILE}", 9)));
      n += 1;
    }
  if ((((1 << (M2Reserved_vartok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KVAR}", 7)));
      n += 1;
    }
  if ((((1 << (M2Reserved_untiltok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KUNTIL}", 9)));
      n += 1;
    }
  if ((((1 << (M2Reserved_typetok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KTYPE}", 8)));
      n += 1;
    }
  if ((((1 << (M2Reserved_totok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KTO}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_thentok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KTHEN}", 8)));
      n += 1;
    }
  if ((((1 << (M2Reserved_settok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KSET}", 7)));
      n += 1;
    }
  if ((((1 << (M2Reserved_returntok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KRETURN}", 10)));
      n += 1;
    }
  if ((((1 << (M2Reserved_retrytok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KRETRY}", 9)));
      n += 1;
    }
  if ((((1 << (M2Reserved_repeattok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KREPEAT}", 10)));
      n += 1;
    }
  if ((((1 << (M2Reserved_remtok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KREM}", 7)));
      n += 1;
    }
  if ((((1 << (M2Reserved_recordtok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KRECORD}", 10)));
      n += 1;
    }
  if ((((1 << (M2Reserved_unqualifiedtok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KUNQUALIFIED}", 15)));
      n += 1;
    }
  if ((((1 << (M2Reserved_qualifiedtok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KQUALIFIED}", 13)));
      n += 1;
    }
  if ((((1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KPROCEDURE}", 13)));
      n += 1;
    }
  if ((((1 << (M2Reserved_pointertok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KPOINTER}", 11)));
      n += 1;
    }
  if ((((1 << (M2Reserved_packedsettok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KPACKEDSET}", 13)));
      n += 1;
    }
  if ((((1 << (M2Reserved_ortok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KOR}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_oftok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KOF}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_nottok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KNOT}", 7)));
      n += 1;
    }
  if ((((1 << (M2Reserved_moduletok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KMODULE}", 10)));
      n += 1;
    }
  if ((((1 << (M2Reserved_modtok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KMOD}", 7)));
      n += 1;
    }
  if ((((1 << (M2Reserved_looptok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KLOOP}", 8)));
      n += 1;
    }
  if ((((1 << (M2Reserved_intok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KIN}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_importtok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KIMPORT}", 10)));
      n += 1;
    }
  if ((((1 << (M2Reserved_implementationtok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KIMPLEMENTATION}", 18)));
      n += 1;
    }
  if ((((1 << (M2Reserved_iftok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KIF}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_fromtok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KFROM}", 8)));
      n += 1;
    }
  if ((((1 << (M2Reserved_fortok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KFOR}", 7)));
      n += 1;
    }
  if ((((1 << (M2Reserved_finallytok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KFINALLY}", 11)));
      n += 1;
    }
  if ((((1 << (M2Reserved_exporttok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KEXPORT}", 10)));
      n += 1;
    }
  if ((((1 << (M2Reserved_exittok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KEXIT}", 8)));
      n += 1;
    }
  if ((((1 << (M2Reserved_excepttok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KEXCEPT}", 10)));
      n += 1;
    }
  if ((((1 << (M2Reserved_endtok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KEND}", 7)));
      n += 1;
    }
  if ((((1 << (M2Reserved_elsiftok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KELSIF}", 9)));
      n += 1;
    }
  if ((((1 << (M2Reserved_elsetok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KELSE}", 8)));
      n += 1;
    }
  if ((((1 << (M2Reserved_dotok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KDO}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_divtok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KDIV}", 7)));
      n += 1;
    }
  if ((((1 << (M2Reserved_definitiontok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KDEFINITION}", 14)));
      n += 1;
    }
  if ((((1 << (M2Reserved_consttok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KCONST}", 9)));
      n += 1;
    }
  if ((((1 << (M2Reserved_casetok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KCASE}", 8)));
      n += 1;
    }
  if ((((1 << (M2Reserved_bytok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KBY}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_begintok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KBEGIN}", 9)));
      n += 1;
    }
  if ((((1 << (M2Reserved_arraytok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KARRAY}", 9)));
      n += 1;
    }
  if ((((1 << (M2Reserved_andtok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KAND}", 7)));
      n += 1;
    }
  if ((((1 << (M2Reserved_colontok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K:}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_periodperiodtok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K..}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_rdirectivetok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K*>}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K<*}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_greaterequaltok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K>=}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_lessequaltok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K<=}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_lessgreatertok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K<>}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_hashtok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K#}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_equaltok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K=}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_uparrowtok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K^}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_semicolontok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K;}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_commatok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K,}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_periodtok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K.}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_ambersandtok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K&}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_dividetok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K/}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_timestok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K*}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_minustok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K-}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_plustok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K+}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_doublequotestok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCatChar (DynamicStrings_ConCatChar (DynamicStrings_ConCatChar (DynamicStrings_ConCatChar (DynamicStrings_ConCatChar (message, ' '), '`'), '"'), '\''), ',');
      n += 1;
    }
  if ((((1 << (M2Reserved_singlequotetok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCatChar (DynamicStrings_ConCatChar (DynamicStrings_ConCatChar (DynamicStrings_ConCatChar (DynamicStrings_ConCatChar (message, ' '), '"'), '\''), '"'), ',');
      n += 1;
    }
  if ((((1 << (M2Reserved_greatertok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K>}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_lesstok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K<}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_rparatok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K)}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K(}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_rcbratok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K%}}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_lcbratok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K%{}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_rsbratok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K]}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K[}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_bartok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K|}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_becomestok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K:=}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_eoftok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {}  /* empty.  */
  /* eoftok has no token name (needed to generate error messages)  */
  if (n == 0)
    {
      str = DynamicStrings_InitString ((const char *) " syntax error", 13);
      message = DynamicStrings_KillString (message);
    }
  else if (n == 1)
    {
      /* avoid dangling else.  */
      str = DynamicStrings_ConCat (message, DynamicStrings_Mark (DynamicStrings_InitString ((const char *) " missing ", 9)));
    }
  else
    {
      /* avoid dangling else.  */
      str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) " expecting one of", 17), message);
      message = DynamicStrings_KillString (message);
    }
  return str;
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   DescribeError - issues a message explaining what tokens were expected
*/

static void DescribeError (void)
{
  DynamicStrings_String str;

  str = DynamicStrings_InitString ((const char *) "", 0);
  switch (M2LexBuf_currenttoken)
    {
      case M2Reserved_stringtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%Kstring}", 30), DynamicStrings_Mark (str));
        break;

      case M2Reserved_realtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%Kreal number}", 35), DynamicStrings_Mark (str));
        break;

      case M2Reserved_identtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%Kidentifier}", 34), DynamicStrings_Mark (str));
        break;

      case M2Reserved_integertok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%Kinteger number}", 38), DynamicStrings_Mark (str));
        break;

      case M2Reserved_inlinetok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K__INLINE__}", 34), DynamicStrings_Mark (str));
        break;

      case M2Reserved_builtintok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K__BUILTIN__}", 35), DynamicStrings_Mark (str));
        break;

      case M2Reserved_attributetok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K__ATTRIBUTE__}", 37), DynamicStrings_Mark (str));
        break;

      case M2Reserved_filetok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K__FILE__}", 32), DynamicStrings_Mark (str));
        break;

      case M2Reserved_linetok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K__LINE__}", 32), DynamicStrings_Mark (str));
        break;

      case M2Reserved_datetok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K__DATE__}", 32), DynamicStrings_Mark (str));
        break;

      case M2Reserved_periodperiodperiodtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K...}", 27), DynamicStrings_Mark (str));
        break;

      case M2Reserved_volatiletok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KVOLATILE}", 32), DynamicStrings_Mark (str));
        break;

      case M2Reserved_asmtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KASM}", 27), DynamicStrings_Mark (str));
        break;

      case M2Reserved_withtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KWITH}", 28), DynamicStrings_Mark (str));
        break;

      case M2Reserved_whiletok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KWHILE}", 29), DynamicStrings_Mark (str));
        break;

      case M2Reserved_vartok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KVAR}", 27), DynamicStrings_Mark (str));
        break;

      case M2Reserved_untiltok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KUNTIL}", 29), DynamicStrings_Mark (str));
        break;

      case M2Reserved_typetok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KTYPE}", 28), DynamicStrings_Mark (str));
        break;

      case M2Reserved_totok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KTO}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_thentok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KTHEN}", 28), DynamicStrings_Mark (str));
        break;

      case M2Reserved_settok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KSET}", 27), DynamicStrings_Mark (str));
        break;

      case M2Reserved_returntok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KRETURN}", 30), DynamicStrings_Mark (str));
        break;

      case M2Reserved_retrytok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KRETRY}", 29), DynamicStrings_Mark (str));
        break;

      case M2Reserved_repeattok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KREPEAT}", 30), DynamicStrings_Mark (str));
        break;

      case M2Reserved_remtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KREM}", 27), DynamicStrings_Mark (str));
        break;

      case M2Reserved_recordtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KRECORD}", 30), DynamicStrings_Mark (str));
        break;

      case M2Reserved_unqualifiedtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KUNQUALIFIED}", 35), DynamicStrings_Mark (str));
        break;

      case M2Reserved_qualifiedtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KQUALIFIED}", 33), DynamicStrings_Mark (str));
        break;

      case M2Reserved_proceduretok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KPROCEDURE}", 33), DynamicStrings_Mark (str));
        break;

      case M2Reserved_pointertok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KPOINTER}", 31), DynamicStrings_Mark (str));
        break;

      case M2Reserved_packedsettok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KPACKEDSET}", 33), DynamicStrings_Mark (str));
        break;

      case M2Reserved_ortok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KOR}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_oftok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KOF}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_nottok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KNOT}", 27), DynamicStrings_Mark (str));
        break;

      case M2Reserved_moduletok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KMODULE}", 30), DynamicStrings_Mark (str));
        break;

      case M2Reserved_modtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KMOD}", 27), DynamicStrings_Mark (str));
        break;

      case M2Reserved_looptok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KLOOP}", 28), DynamicStrings_Mark (str));
        break;

      case M2Reserved_intok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KIN}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_importtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KIMPORT}", 30), DynamicStrings_Mark (str));
        break;

      case M2Reserved_implementationtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KIMPLEMENTATION}", 38), DynamicStrings_Mark (str));
        break;

      case M2Reserved_iftok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KIF}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_fromtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KFROM}", 28), DynamicStrings_Mark (str));
        break;

      case M2Reserved_fortok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KFOR}", 27), DynamicStrings_Mark (str));
        break;

      case M2Reserved_finallytok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KFINALLY}", 31), DynamicStrings_Mark (str));
        break;

      case M2Reserved_exporttok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KEXPORT}", 30), DynamicStrings_Mark (str));
        break;

      case M2Reserved_exittok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KEXIT}", 28), DynamicStrings_Mark (str));
        break;

      case M2Reserved_excepttok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KEXCEPT}", 30), DynamicStrings_Mark (str));
        break;

      case M2Reserved_endtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KEND}", 27), DynamicStrings_Mark (str));
        break;

      case M2Reserved_elsiftok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KELSIF}", 29), DynamicStrings_Mark (str));
        break;

      case M2Reserved_elsetok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KELSE}", 28), DynamicStrings_Mark (str));
        break;

      case M2Reserved_dotok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KDO}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_divtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KDIV}", 27), DynamicStrings_Mark (str));
        break;

      case M2Reserved_definitiontok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KDEFINITION}", 34), DynamicStrings_Mark (str));
        break;

      case M2Reserved_consttok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KCONST}", 29), DynamicStrings_Mark (str));
        break;

      case M2Reserved_casetok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KCASE}", 28), DynamicStrings_Mark (str));
        break;

      case M2Reserved_bytok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KBY}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_begintok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KBEGIN}", 29), DynamicStrings_Mark (str));
        break;

      case M2Reserved_arraytok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KARRAY}", 29), DynamicStrings_Mark (str));
        break;

      case M2Reserved_andtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KAND}", 27), DynamicStrings_Mark (str));
        break;

      case M2Reserved_colontok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K:}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_periodperiodtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K..}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_rdirectivetok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K*>}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_ldirectivetok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K<*}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_greaterequaltok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K>=}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_lessequaltok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K<=}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_lessgreatertok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K<>}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_hashtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K#}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_equaltok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K=}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_uparrowtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K^}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_semicolontok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K;}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_commatok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K,}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_periodtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K.}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_ambersandtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K&}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_dividetok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K/}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_timestok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K*}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_minustok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K-}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_plustok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K+}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_doublequotestok:
        str = DynamicStrings_ConCat (DynamicStrings_ConCatChar (DynamicStrings_ConCatChar (DynamicStrings_InitString ((const char *) "syntax error, found '", 21), '"'), '\''), DynamicStrings_Mark (str));
        break;

      case M2Reserved_singlequotetok:
        str = DynamicStrings_ConCat (DynamicStrings_ConCatChar (DynamicStrings_ConCatChar (DynamicStrings_InitString ((const char *) "syntax error, found \"", 21), '\''), '"'), DynamicStrings_Mark (str));
        break;

      case M2Reserved_greatertok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K>}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_lesstok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K<}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_rparatok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K)}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_lparatok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K(}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_rcbratok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K%}}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_lcbratok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K%{}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_rsbratok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K]}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_lsbratok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K[}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_bartok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K|}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_becomestok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K:=}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_eoftok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K}", 24), DynamicStrings_Mark (str));
        break;


      default:
        break;
    }
  ErrorString (str);
}


/*
   checkReturnAttribute -
*/

static void checkReturnAttribute (void)
{
  NameKey_Name ident;
  unsigned int tok;

  M2Quads_PopTtok (&ident, &tok);
  if (ident != (NameKey_MakeKey ((const char *) "noreturn", 8)))
    {
      M2MetaError_MetaErrorT1 (tok, (const char *) "attribute {%1k} is not allowed in the procedure return type, only noreturn is allowed", 85, ident);
    }
}


/*
   checkParameterAttribute -
*/

static void checkParameterAttribute (void)
{
  NameKey_Name ident;
  unsigned int tok;

  M2Quads_PopTtok (&ident, &tok);
  if (ident != (NameKey_MakeKey ((const char *) "unused", 6)))
    {
      M2MetaError_MetaErrorT1 (tok, (const char *) "attribute {%1k} is not allowed in the parameter formal type section, only unused is allowed", 91, ident);
    }
}


/*
   SyntaxError - after a syntax error we skip all tokens up until we reach
                 a stop symbol.
*/

static void SyntaxError (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  DescribeError ();
  if (Debugging)
    {
      M2Printf_printf0 ((const char *) "\\nskipping token *** ", 21);
    }
  /* --fixme-- this assumes a 32 bit word size.  */
  while (! (((( ((unsigned int) (M2LexBuf_currenttoken)) < 32) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & (stopset0)) != 0))) || ((( ((unsigned int) (M2LexBuf_currenttoken)) >= 32) && ( ((unsigned int) (M2LexBuf_currenttoken)) < 64)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & (stopset1)) != 0)))) || (( ((unsigned int) (M2LexBuf_currenttoken)) >= 64) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & (stopset2)) != 0)))))
    {
      M2LexBuf_GetToken ();
    }
  if (Debugging)
    {
      M2Printf_printf0 ((const char *) " ***\\n", 6);
    }
}


/*
   SyntaxCheck -
*/

static void SyntaxCheck (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  /* --fixme-- this assumes a 32 bit word size.  */
  if (! (((( ((unsigned int) (M2LexBuf_currenttoken)) < 32) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & (stopset0)) != 0))) || ((( ((unsigned int) (M2LexBuf_currenttoken)) >= 32) && ( ((unsigned int) (M2LexBuf_currenttoken)) < 64)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & (stopset1)) != 0)))) || (( ((unsigned int) (M2LexBuf_currenttoken)) >= 64) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & (stopset2)) != 0)))))
    {
      SyntaxError (stopset0, stopset1, stopset2);
    }
}


/*
   WarnMissingToken - generates a warning message about a missing token, t.
*/

static void WarnMissingToken (M2Reserved_toktype t)
{
  P2Build_SetOfStop0 s0;
  P2Build_SetOfStop1 s1;
  P2Build_SetOfStop2 s2;
  DynamicStrings_String str;

  s0 = (P2Build_SetOfStop0) 0;
  s1 = (P2Build_SetOfStop1) 0;
  s2 = (P2Build_SetOfStop2) 0;
  if ( ((unsigned int) (t)) < 32)
    {
      s0 |= (1 << (t-M2Reserved_eoftok ));
    }
  else if ( ((unsigned int) (t)) < 64)
    {
      /* avoid dangling else.  */
      s1 |= (1 << (t-M2Reserved_arraytok ));
    }
  else
    {
      /* avoid dangling else.  */
      s2 |= (1 << (t-M2Reserved_recordtok ));
    }
  str = DescribeStop (s0, s1, s2);
  str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error,", 13), DynamicStrings_Mark (str));
  M2MetaError_MetaErrorStringT0 (M2LexBuf_GetTokenNo (), str);
}


/*
   MissingToken - generates a warning message about a missing token, t.
*/

static void MissingToken (M2Reserved_toktype t)
{
  WarnMissingToken (t);
  if ((((t != M2Reserved_identtok) && (t != M2Reserved_integertok)) && (t != M2Reserved_realtok)) && (t != M2Reserved_stringtok))
    {
      if (Debugging)
        {
          M2Printf_printf0 ((const char *) "inserting token\\n", 17);
        }
      M2LexBuf_InsertToken (t);
    }
}


/*
   CheckAndInsert -
*/

static bool CheckAndInsert (M2Reserved_toktype t, P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (((( ((unsigned int) (t)) < 32) && ((((1 << (t-M2Reserved_eoftok)) & (stopset0)) != 0))) || ((( ((unsigned int) (t)) >= 32) && ( ((unsigned int) (t)) < 64)) && ((((1 << (t-M2Reserved_arraytok)) & (stopset1)) != 0)))) || (( ((unsigned int) (t)) >= 64) && ((((1 << (t-M2Reserved_recordtok)) & (stopset2)) != 0))))
    {
      WarnMissingToken (t);
      M2LexBuf_InsertTokenAndRewind (t);
      return true;
    }
  else
    {
      return false;
    }
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   InStopSet
*/

static bool InStopSet (M2Reserved_toktype t, P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (((( ((unsigned int) (t)) < 32) && ((((1 << (t-M2Reserved_eoftok)) & (stopset0)) != 0))) || ((( ((unsigned int) (t)) >= 32) && ( ((unsigned int) (t)) < 64)) && ((((1 << (t-M2Reserved_arraytok)) & (stopset1)) != 0)))) || (( ((unsigned int) (t)) >= 64) && ((((1 << (t-M2Reserved_recordtok)) & (stopset2)) != 0))))
    {
      return true;
    }
  else
    {
      return false;
    }
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   PeepToken - peep token checks to see whether the stopset is satisfied by currenttoken
               If it is not then it will insert a token providing the token
               is one of ; ] ) } . OF END ,

               if the stopset contains <identtok> then we do not insert a token
*/

static void PeepToken (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  /* and again (see above re: ORD)
  */
  if ((! (((( ((unsigned int) (M2LexBuf_currenttoken)) < 32) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & (stopset0)) != 0))) || ((( ((unsigned int) (M2LexBuf_currenttoken)) >= 32) && ( ((unsigned int) (M2LexBuf_currenttoken)) < 64)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & (stopset1)) != 0)))) || (( ((unsigned int) (M2LexBuf_currenttoken)) >= 64) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & (stopset2)) != 0))))) && (! (InStopSet (M2Reserved_identtok, stopset0, stopset1, stopset2))))
    {
      /* SyntaxCheck would fail since currentoken is not part of the stopset
         we check to see whether any of currenttoken might be a commonly omitted token  */
      if ((((((((CheckAndInsert (M2Reserved_semicolontok, stopset0, stopset1, stopset2)) || (CheckAndInsert (M2Reserved_rsbratok, stopset0, stopset1, stopset2))) || (CheckAndInsert (M2Reserved_rparatok, stopset0, stopset1, stopset2))) || (CheckAndInsert (M2Reserved_rcbratok, stopset0, stopset1, stopset2))) || (CheckAndInsert (M2Reserved_periodtok, stopset0, stopset1, stopset2))) || (CheckAndInsert (M2Reserved_oftok, stopset0, stopset1, stopset2))) || (CheckAndInsert (M2Reserved_endtok, stopset0, stopset1, stopset2))) || (CheckAndInsert (M2Reserved_commatok, stopset0, stopset1, stopset2)))
        {}  /* empty.  */
    }
}


/*
   Expect -
*/

static void Expect (M2Reserved_toktype t, P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == t)
    {
      /* avoid dangling else.  */
      M2LexBuf_GetToken ();
      if (Pass1)
        {
          PeepToken (stopset0, stopset1, stopset2);
        }
    }
  else
    {
      MissingToken (t);
    }
  SyntaxCheck (stopset0, stopset1, stopset2);
}


/*
   Ident - error checking varient of Ident
*/

static void Ident (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2Quads_IsAutoPushOn ())
    {
      M2Quads_PushTFtok (NameKey_makekey (M2LexBuf_currentstring), static_cast<unsigned int> (M2Reserved_identtok), M2LexBuf_GetTokenNo ());
      M2Quads_Annotate ((const char *) "%1n|identtok||Ident rule", 24);
    }
  Expect (M2Reserved_identtok, stopset0, stopset1, stopset2);
}


/*
   string -
*/

static void string (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2Quads_IsAutoPushOn ())
    {
      M2Quads_PushTF (NameKey_makekey (M2LexBuf_currentstring), static_cast<unsigned int> (M2Reserved_stringtok));
      P2SymBuild_BuildString ();
    }
  Expect (M2Reserved_stringtok, stopset0, stopset1, stopset2);
}


/*
   Integer -
*/

static void Integer (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2Quads_IsAutoPushOn ())
    {
      M2Quads_PushTFtok (NameKey_makekey (M2LexBuf_currentstring), static_cast<unsigned int> (M2Reserved_integertok), M2LexBuf_GetTokenNo ());
      P2SymBuild_BuildNumber ();
    }
  Expect (M2Reserved_integertok, stopset0, stopset1, stopset2);
}


/*
   Real -
*/

static void Real (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2Quads_IsAutoPushOn ())
    {
      M2Quads_PushTFtok (NameKey_makekey (M2LexBuf_currentstring), static_cast<unsigned int> (M2Reserved_realtok), M2LexBuf_GetTokenNo ());
      P2SymBuild_BuildNumber ();
    }
  Expect (M2Reserved_realtok, stopset0, stopset1, stopset2);
}


/*
   FileUnit := 
               % PushAutoOn  %
               ( DefinitionModule  | 
                 ImplementationOrProgramModule  ) 
               % PopAuto  %
               

   first  symbols:implementationtok, moduletok, definitiontok
   
   cannot reachend
*/

static void FileUnit (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  M2Quads_PushAutoOn ();
  if (M2LexBuf_currenttoken == M2Reserved_definitiontok)
    {
      DefinitionModule (stopset0, stopset1, stopset2);
    }
  else if (((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P2Build_SetOfStop1) ((1 << (M2Reserved_implementationtok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok))))) != 0)))
    {
      /* avoid dangling else.  */
      ImplementationOrProgramModule (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KIMPLEMENTATION} {%KMODULE} {%KDEFINITION}", 62);
    }
  M2Quads_PopAuto ();
}


/*
   ProgramModule := 'MODULE' 
                    % M2Error.DefaultProgramModule  %
                    
                    % BlockStart (GetTokenNo () -1)  %
                    Ident 
                    % P2StartBuildProgramModule ;  %
                    [ Priority  ] ';' { Import 
                                        % BuildImportOuterModule ;  %
                                         } Block 
                    % BlockEnd (GetTokenNo () -1)  %
                    Ident 
                    % P2EndBuildProgramModule ;  %
                    '.' 

   first  symbols:moduletok
   
   cannot reachend
*/

static void ProgramModule (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_moduletok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Error_DefaultProgramModule ();
  P2SymBuild_BlockStart ((M2LexBuf_GetTokenNo ())-1);
  Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2);
  P2SymBuild_P2StartBuildProgramModule ();
  if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
    {
      Priority (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  Expect (M2Reserved_semicolontok, stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_importtok-M2Reserved_arraytok)) | (1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_finallytok-M2Reserved_arraytok)) | (1 << (M2Reserved_begintok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
  while (((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P2Build_SetOfStop1) ((1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_importtok-M2Reserved_arraytok))))) != 0)))
    {
      Import (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_importtok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_begintok-M2Reserved_arraytok)) | (1 << (M2Reserved_finallytok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_vartok-M2Reserved_recordtok)) | (1 << (M2Reserved_typetok-M2Reserved_recordtok))));
      P2SymBuild_BuildImportOuterModule ();
    }
   /* while  */
  Block (stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  P2SymBuild_BlockEnd ((M2LexBuf_GetTokenNo ())-1);
  Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_periodtok-M2Reserved_eoftok))), stopset1, stopset2);
  P2SymBuild_P2EndBuildProgramModule ();
  Expect (M2Reserved_periodtok, stopset0, stopset1, stopset2);
}


/*
   ImplementationModule := 'IMPLEMENTATION' 
                           % M2Error.DefaultImplementationModule  %
                           
                           % BlockStart (GetTokenNo () -1)  %
                           'MODULE' Ident 
                           % P2StartBuildImplementationModule ;  %
                           [ Priority  ] ';' { Import 
                                               
                                               % BuildImportOuterModule  %
                                                } Block 
                           
                           % BlockEnd (GetTokenNo () -1)  %
                           Ident 
                           % P2EndBuildImplementationModule ;  %
                           '.' 

   first  symbols:implementationtok
   
   cannot reachend
*/

static void ImplementationModule (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_implementationtok, stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_moduletok-M2Reserved_arraytok))), stopset2);
  M2Error_DefaultImplementationModule ();
  P2SymBuild_BlockStart ((M2LexBuf_GetTokenNo ())-1);
  Expect (M2Reserved_moduletok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2);
  P2SymBuild_P2StartBuildImplementationModule ();
  if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
    {
      Priority (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  Expect (M2Reserved_semicolontok, stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_importtok-M2Reserved_arraytok)) | (1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_finallytok-M2Reserved_arraytok)) | (1 << (M2Reserved_begintok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
  while (((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P2Build_SetOfStop1) ((1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_importtok-M2Reserved_arraytok))))) != 0)))
    {
      Import (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_importtok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_begintok-M2Reserved_arraytok)) | (1 << (M2Reserved_finallytok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_vartok-M2Reserved_recordtok)) | (1 << (M2Reserved_typetok-M2Reserved_recordtok))));
      P2SymBuild_BuildImportOuterModule ();
    }
   /* while  */
  Block (stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  P2SymBuild_BlockEnd ((M2LexBuf_GetTokenNo ())-1);
  Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_periodtok-M2Reserved_eoftok))), stopset1, stopset2);
  P2SymBuild_P2EndBuildImplementationModule ();
  Expect (M2Reserved_periodtok, stopset0, stopset1, stopset2);
}


/*
   ImplementationOrProgramModule := ImplementationModule  | 
                                    ProgramModule 

   first  symbols:moduletok, implementationtok
   
   cannot reachend
*/

static void ImplementationOrProgramModule (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_implementationtok)
    {
      ImplementationModule (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_moduletok)
    {
      /* avoid dangling else.  */
      ProgramModule (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KMODULE} {%KIMPLEMENTATION}", 47);
    }
}


/*
   Number := Integer  | Real 

   first  symbols:realtok, integertok
   
   cannot reachend
*/

static void Number (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_integertok)
    {
      Integer (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_realtok)
    {
      /* avoid dangling else.  */
      Real (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%Kreal number} {%Kinteger number}", 52);
    }
}


/*
   Qualident := 
                % VAR name: Name ;
                      Type, Sym, tok: CARDINAL ;  %
                Ident 
                % IF IsAutoPushOn()
                  THEN
                     PopTtok(name, tok) ;
                     Sym := RequestSym (tok, name) ;
                     IF IsDefImp(Sym) OR IsModule(Sym)
                     THEN
                        Expect(periodtok, stopset0, stopset1, stopset2 + SetOfStop2{identtok}) ;
                        StartScope(Sym) ;
                        Qualident(stopset0, stopset1, stopset2) ;
                         should we test for lack of ident? 
                        PopTFtok(Sym, Type, tok) ;
                        PushTFtok(Sym, Type, tok) ;
                        Annotate("%1s(%1d)|%1s(%1d)||qualident|type") ;
                        EndScope ;
                        PutIncluded(Sym)
                     ELSE
                        PushTFtok(Sym, GetType(Sym), tok) ;
                        Annotate("%1s(%1d)|%1s(%1d)||qualident|type")
                     END
                  ELSE  just parse qualident   %
                { '.' Ident  } 
                % END  %
                

   first  symbols:identtok
   
   cannot reachend
*/

static void Qualident (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  NameKey_Name name;
  unsigned int Type;
  unsigned int Sym;
  unsigned int tok;

  Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_periodtok-M2Reserved_eoftok))), stopset1, stopset2);
  if (M2Quads_IsAutoPushOn ())
    {
      M2Quads_PopTtok (&name, &tok);
      Sym = SymbolTable_RequestSym (tok, name);
      if ((SymbolTable_IsDefImp (Sym)) || (SymbolTable_IsModule (Sym)))
        {
          Expect (M2Reserved_periodtok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
          SymbolTable_StartScope (Sym);
          Qualident (stopset0, stopset1, stopset2);
          /* should we test for lack of ident?  */
          M2Quads_PopTFtok (&Sym, &Type, &tok);
          M2Quads_PushTFtok (Sym, Type, tok);
          M2Quads_Annotate ((const char *) "%1s(%1d)|%1s(%1d)||qualident|type", 33);
          SymbolTable_EndScope ();
          SymbolTable_PutIncluded (Sym);
        }
      else
        {
          M2Quads_PushTFtok (Sym, SymbolTable_GetType (Sym), tok);
          M2Quads_Annotate ((const char *) "%1s(%1d)|%1s(%1d)||qualident|type", 33);
        }
       /* just parse qualident  */
    }
  else
    {
      while (M2LexBuf_currenttoken == M2Reserved_periodtok)  /* just parse qualident  */
        {
          Expect (M2Reserved_periodtok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
          Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_periodtok-M2Reserved_eoftok))), stopset1, stopset2);
        }
       /* while  */
    }
}


/*
   ConstantDeclaration := Ident '=' 
                          % SeenUnknown ;
                            BuildConst  %
                          ConstExpressionInitial 
                          % DetermineType ;
                            PopNothing  %
                          

   first  symbols:identtok
   
   cannot reachend
*/

static void ConstantDeclaration (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_equaltok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_equaltok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
  P2SymBuild_SeenUnknown ();
  P2SymBuild_BuildConst ();
  ConstExpressionInitial (stopset0, stopset1, stopset2);
  P2SymBuild_DetermineType ();
  M2Quads_PopNothing ();
}


/*
   ConstExpressionInitial := 
                             % PushAutoOff  %
                             SimpleConstExpr [ Relation 
                                               SimpleConstExpr  ] 
                             
                             % PopAuto  %
                             

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void ConstExpressionInitial (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  M2Quads_PushAutoOff ();
  SimpleConstExpr (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_greaterequaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_greatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessequaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_lesstok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessgreatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_hashtok-M2Reserved_eoftok)) | (1 << (M2Reserved_equaltok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_intok-M2Reserved_arraytok))), stopset2);
  if (((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_equaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_hashtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessgreatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_lesstok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessequaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_greatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_greaterequaltok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_intok))
    {
      Relation (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
      SimpleConstExpr (stopset0, stopset1, stopset2);
    }
  M2Quads_PopAuto ();
}


/*
   ConstExpression := 
                      % PushType ; SeenUnknown ; PushAutoOff  %
                      SimpleConstExpr [ Relation SimpleConstExpr  ] 
                      
                      % PopAuto ; PopType  %
                      

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void ConstExpression (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  P2SymBuild_PushType ();
  P2SymBuild_SeenUnknown ();
  M2Quads_PushAutoOff ();
  SimpleConstExpr (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_greaterequaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_greatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessequaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_lesstok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessgreatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_hashtok-M2Reserved_eoftok)) | (1 << (M2Reserved_equaltok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_intok-M2Reserved_arraytok))), stopset2);
  if (((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_equaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_hashtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessgreatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_lesstok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessequaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_greatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_greaterequaltok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_intok))
    {
      Relation (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
      SimpleConstExpr (stopset0, stopset1, stopset2);
    }
  M2Quads_PopAuto ();
  P2SymBuild_PopType ();
}


/*
   Relation := 
               % SeenUnknown  actually it will be a BOOLEAN, but this is not a constructor and not a string   %
               '='  | '#'  | '<>'  | '<'  | '<='  | 
               '>'  | '>='  | 'IN' 

   first  symbols:intok, greaterequaltok, greatertok, lessequaltok, lesstok, lessgreatertok, hashtok, equaltok
   
   cannot reachend
*/

static void Relation (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_equaltok)
    {
      Expect (M2Reserved_equaltok, stopset0, stopset1, stopset2);
      P2SymBuild_SeenUnknown ();  /* actually it will be a BOOLEAN, but this is not a constructor and not a string  */
    }
  else if (M2LexBuf_currenttoken == M2Reserved_hashtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_hashtok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lessgreatertok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_lessgreatertok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lesstok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_lesstok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lessequaltok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_lessequaltok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_greatertok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_greatertok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_greaterequaltok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_greaterequaltok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_intok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_intok, stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KIN} {%K>=} {%K>} {%K<=} {%K<} {%K<>} {%K#} {%K=}", 69);
    }
}


/*
   SimpleConstExpr := UnaryOrConstTerm { AddOperator 
                                         ConstTerm  } 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void SimpleConstExpr (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  UnaryOrConstTerm (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_ortok-M2Reserved_arraytok))), stopset2);
  while (((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_ortok))
    {
      AddOperator (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
      ConstTerm (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_ortok-M2Reserved_arraytok))), stopset2);
    }
   /* while  */
}


/*
   UnaryOrConstTerm := '+' ConstTerm  | 
                       '-' ConstTerm  | 
                       ConstTerm 

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void UnaryOrConstTerm (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_plustok)
    {
      Expect (M2Reserved_plustok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
      ConstTerm (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_minustok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_minustok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
      ConstTerm (stopset0, stopset1, stopset2);
    }
  else if ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_nottok)) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))))) != 0))))
    {
      /* avoid dangling else.  */
      ConstTerm (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KNOT} {%K(} {%Kinteger number} {%Kreal number} {%K__ATTRIBUTE__} {%K%{} {%Kidentifier} {%Kstring} {%K-} {%K+}", 129);
    }
}


/*
   AddOperator := '+'  | '-'  | 'OR' 
                  % SeenUnknown  actually it will be a BOOLEAN, but this is not a constructor and not a string   %
                  

   first  symbols:ortok, minustok, plustok
   
   cannot reachend
*/

static void AddOperator (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_plustok)
    {
      Expect (M2Reserved_plustok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_minustok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_minustok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_ortok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_ortok, stopset0, stopset1, stopset2);
      P2SymBuild_SeenUnknown ();  /* actually it will be a BOOLEAN, but this is not a constructor and not a string  */
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KOR} {%K-} {%K+}", 36);
    }
}


/*
   ConstTerm := ConstFactor { MulOperator ConstFactor  } 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok
   
   cannot reachend
*/

static void ConstTerm (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  ConstFactor (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_ambersandtok-M2Reserved_eoftok)) | (1 << (M2Reserved_andtok-M2Reserved_eoftok)) | (1 << (M2Reserved_dividetok-M2Reserved_eoftok)) | (1 << (M2Reserved_timestok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_modtok-M2Reserved_arraytok)) | (1 << (M2Reserved_divtok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_remtok-M2Reserved_recordtok))));
  while ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_timestok-M2Reserved_eoftok)) | (1 << (M2Reserved_dividetok-M2Reserved_eoftok)) | (1 << (M2Reserved_andtok-M2Reserved_eoftok)) | (1 << (M2Reserved_ambersandtok-M2Reserved_eoftok))))) != 0))) || (((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P2Build_SetOfStop1) ((1 << (M2Reserved_divtok-M2Reserved_arraytok)) | (1 << (M2Reserved_modtok-M2Reserved_arraytok))))) != 0)))) || (M2LexBuf_currenttoken == M2Reserved_remtok))
    {
      MulOperator (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      ConstFactor (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_timestok-M2Reserved_eoftok)) | (1 << (M2Reserved_dividetok-M2Reserved_eoftok)) | (1 << (M2Reserved_andtok-M2Reserved_eoftok)) | (1 << (M2Reserved_ambersandtok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_divtok-M2Reserved_arraytok)) | (1 << (M2Reserved_modtok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_remtok-M2Reserved_recordtok))));
    }
   /* while  */
}


/*
   MulOperator := '*'  | '/'  | 'DIV' 
                  % SeenUnknown  %
                   | 'MOD' 
                  % SeenUnknown  %
                   | 'REM' 
                  % SeenUnknown  %
                   | 'AND' 
                  % SeenUnknown  %
                   | '&' 
                  % SeenUnknown  %
                  

   first  symbols:ambersandtok, andtok, remtok, modtok, divtok, dividetok, timestok
   
   cannot reachend
*/

static void MulOperator (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_timestok)
    {
      Expect (M2Reserved_timestok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_dividetok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_dividetok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_divtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_divtok, stopset0, stopset1, stopset2);
      P2SymBuild_SeenUnknown ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_modtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_modtok, stopset0, stopset1, stopset2);
      P2SymBuild_SeenUnknown ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_remtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_remtok, stopset0, stopset1, stopset2);
      P2SymBuild_SeenUnknown ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_andtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_andtok, stopset0, stopset1, stopset2);
      P2SymBuild_SeenUnknown ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_ambersandtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_ambersandtok, stopset0, stopset1, stopset2);
      P2SymBuild_SeenUnknown ();
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%K&} {%KAND} {%KREM} {%KMOD} {%KDIV} {%K/} {%K*}", 67);
    }
}


/*
   ConstFactor := Number  | ConstString  | 
                  ConstSetOrQualidentOrFunction  | 
                  '(' ConstExpression ')'  | 
                  'NOT' ConstFactor  | 
                  ConstAttribute 

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok
   
   cannot reachend
*/

static void ConstFactor (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok))))) != 0)))
    {
      Number (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_stringtok)
    {
      /* avoid dangling else.  */
      ConstString (stopset0, stopset1, stopset2);
    }
  else if ((M2LexBuf_currenttoken == M2Reserved_lcbratok) || (M2LexBuf_currenttoken == M2Reserved_identtok))
    {
      /* avoid dangling else.  */
      ConstSetOrQualidentOrFunction (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lparatok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_lparatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      ConstExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_nottok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_nottok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      ConstFactor (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_attributetok)
    {
      /* avoid dangling else.  */
      ConstAttribute (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%K__ATTRIBUTE__} {%KNOT} {%K(} {%K%{} {%Kidentifier} {%Kstring} {%Kinteger number} {%Kreal number}", 117);
    }
}


/*
   ConstString := string 
                  % SeenString  %
                  

   first  symbols:stringtok
   
   cannot reachend
*/

static void ConstString (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  string (stopset0, stopset1, stopset2);
  P2SymBuild_SeenString ();
}


/*
   ComponentElement := ConstExpression [ '..' 
                                         % PopType ; SeenSet ; PushType ; SeenUnknown  %
                                         ConstExpression  ] 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void ComponentElement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  ConstExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_periodperiodtok-M2Reserved_eoftok))), stopset1, stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_periodperiodtok)
    {
      Expect (M2Reserved_periodperiodtok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      P2SymBuild_PopType ();
      P2SymBuild_SeenSet ();
      P2SymBuild_PushType ();
      P2SymBuild_SeenUnknown ();
      ConstExpression (stopset0, stopset1, stopset2);
    }
}


/*
   ComponentValue := 
                     % PushType ; SeenUnknown ; PushRememberConstant  %
                     ComponentElement [ 'BY' 
                                        % PopType ; SeenArray ; PushType ; SeenUnknown  %
                                        ConstExpression  ] 
                     
                     % PopType  double check position, it must balance PushType   %
                     
                     % PopRememberConstant  %
                     

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void ComponentValue (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  P2SymBuild_PushType ();
  P2SymBuild_SeenUnknown ();
  P2SymBuild_PushRememberConstant ();
  ComponentElement (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_bytok-M2Reserved_arraytok))), stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_bytok)
    {
      Expect (M2Reserved_bytok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      P2SymBuild_PopType ();
      P2SymBuild_SeenArray ();
      P2SymBuild_PushType ();
      P2SymBuild_SeenUnknown ();
      ConstExpression (stopset0, stopset1, stopset2);
    }
  P2SymBuild_PopType ();  /* double check position, it must balance PushType  */
  P2SymBuild_PopRememberConstant ();
}


/*
   ArraySetRecordValue := ComponentValue { ',' ComponentValue  } 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void ArraySetRecordValue (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  ComponentValue (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      ComponentValue (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
   /* while  */
}


/*
   Constructor := '{' 
                  % SeenConstructor  %
                  [ ArraySetRecordValue  ] '}' 

   first  symbols:lcbratok
   
   cannot reachend
*/

static void Constructor (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_lcbratok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rcbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
  P2SymBuild_SeenConstructor ();
  if ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_nottok)) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))))) != 0))))
    {
      ArraySetRecordValue (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rcbratok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  Expect (M2Reserved_rcbratok, stopset0, stopset1, stopset2);
}


/*
   ConstSetOrQualidentOrFunction := Constructor  | 
                                    Qualident [ Constructor  | 
                                                ConstActualParameters  ] 

   first  symbols:identtok, lcbratok
   
   cannot reachend
*/

static void ConstSetOrQualidentOrFunction (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_lcbratok)
    {
      Constructor (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_identtok)
    {
      /* avoid dangling else.  */
      Qualident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lcbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
      if ((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0)))
        {
          /* avoid gcc warning by using compound statement even if not strictly necessary.  */
          /* seen optional [ | ] expression  */
          if (M2LexBuf_currenttoken == M2Reserved_lcbratok)
            {
              Constructor (stopset0, stopset1, stopset2);
            }
          else if (M2LexBuf_currenttoken == M2Reserved_lparatok)
            {
              /* avoid dangling else.  */
              ConstActualParameters (stopset0, stopset1, stopset2);
            }
          else
            {
              /* avoid dangling else.  */
              ErrorArray ((const char *) "expecting one of: {%K(} {%K%{}", 30);
            }
        }
      /* end of optional [ | ] expression  */
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%Kidentifier} {%K%{}", 39);
    }
}


/*
   ConstActualParameters := 
                            % PushType ; SeenUnknown  %
                            '(' [ ExpList  ] ')' 
                            % PopType  %
                            

   first  symbols:lparatok
   
   cannot reachend
*/

static void ConstActualParameters (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  P2SymBuild_PushType ();
  P2SymBuild_SeenUnknown ();
  Expect (M2Reserved_lparatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  if ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_nottok)) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))))) != 0))))
    {
      ExpList (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
  P2SymBuild_PopType ();
}


/*
   ConstAttribute := '__ATTRIBUTE__' '__BUILTIN__' 
                     '(' '(' ConstAttributeExpression 
                     ')' ')' 

   first  symbols:attributetok
   
   cannot reachend
*/

static void ConstAttribute (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_attributetok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_builtintok-M2Reserved_recordtok))));
  Expect (M2Reserved_builtintok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_lparatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_lparatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lesstok-M2Reserved_eoftok))), stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  ConstAttributeExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_rparatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
}


/*
   ConstAttributeExpression := Ident  | '<' Qualident 
                               ',' Ident '>' 

   first  symbols:lesstok, identtok
   
   cannot reachend
*/

static void ConstAttributeExpression (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_identtok)
    {
      Ident (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lesstok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_lesstok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Qualident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_commatok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_greatertok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_greatertok, stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%K<} {%Kidentifier}", 38);
    }
}


/*
   ByteAlignment := '' 

   first  symbols:ldirectivetok
   
   cannot reachend
*/

static void ByteAlignment (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_ldirectivetok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Quads_PushAutoOn ();
  AttributeExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rdirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
  P2SymBuild_BuildAligned ();
  M2Quads_PopAuto ();
  Expect (M2Reserved_rdirectivetok, stopset0, stopset1, stopset2);
}


/*
   Alignment := ByteAlignment  | 
                % PushT(NulSym)  %
                

   first  symbols:ldirectivetok
   
   reachend
*/

static void Alignment (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_ldirectivetok)
    {
      ByteAlignment (stopset0, stopset1, stopset2);
    }
  else
    {
      M2Quads_PushT (static_cast<unsigned int> (SymbolTable_NulSym));
    }
}


/*
   TypeDeclaration := 
                      % VAR top: CARDINAL ;  %
                      
                      % top := Top()  %
                      Ident '=' Type Alignment 
                      % BuildTypeAlignment  %
                      
                      % Assert(top=Top())  %
                      

   first  symbols:identtok
   
   cannot reachend
*/

static void TypeDeclaration (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  unsigned int top;

  top = M2Quads_Top ();
  Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_equaltok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_equaltok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_pointertok-M2Reserved_arraytok)) | (1 << (M2Reserved_packedsettok-M2Reserved_arraytok)) | (1 << (M2Reserved_oftok-M2Reserved_arraytok)) | (1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_settok-M2Reserved_recordtok)) | (1 << (M2Reserved_recordtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Type (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
  Alignment (stopset0, stopset1, stopset2);
  P2SymBuild_BuildTypeAlignment ();
  M2Debug_Assert (top == (M2Quads_Top ()));
}


/*
   Type := 
           % PushAutoOn ;  %
           ( SimpleType  | ArrayType 
             % BuildType ;  %
              | RecordType 
             % BuildType ;  %
              | SetType 
             % BuildType ;  %
              | PointerType 
             % BuildType ;  %
              | ProcedureType 
             % BuildType ;  %
              ) 
           % PopAuto ;  %
           

   first  symbols:lparatok, lsbratok, proceduretok, pointertok, settok, packedsettok, oftok, recordtok, arraytok, identtok
   
   cannot reachend
*/

static void Type (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  M2Quads_PushAutoOn ();
  if (((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_identtok))
    {
      SimpleType (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_arraytok)
    {
      /* avoid dangling else.  */
      ArrayType (stopset0, stopset1, stopset2);
      P2SymBuild_BuildType ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_recordtok)
    {
      /* avoid dangling else.  */
      RecordType (stopset0, stopset1, stopset2);
      P2SymBuild_BuildType ();
    }
  else if ((((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P2Build_SetOfStop1) ((1 << (M2Reserved_packedsettok-M2Reserved_arraytok)) | (1 << (M2Reserved_oftok-M2Reserved_arraytok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_settok))
    {
      /* avoid dangling else.  */
      SetType (stopset0, stopset1, stopset2);
      P2SymBuild_BuildType ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_pointertok)
    {
      /* avoid dangling else.  */
      PointerType (stopset0, stopset1, stopset2);
      P2SymBuild_BuildType ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_proceduretok)
    {
      /* avoid dangling else.  */
      ProcedureType (stopset0, stopset1, stopset2);
      P2SymBuild_BuildType ();
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KPROCEDURE} {%KPOINTER} {%KSET} {%KPACKEDSET} {%KOF} {%KRECORD} {%KARRAY} {%Kidentifier} {%K(} {%K[}", 120);
    }
  M2Quads_PopAuto ();
}


/*
   SimpleType := ( Qualident [ PrefixedSubrangeType  ] 
                   
                   % BuildType ;  %
                    | 
                   Enumeration 
                   % BuildType ;  %
                    | SubrangeType 
                   % BuildType ;  %
                    ) 

   first  symbols:lsbratok, lparatok, identtok
   
   cannot reachend
*/

static void SimpleType (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_identtok)
    {
      Qualident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2);
      if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
        {
          PrefixedSubrangeType (stopset0, stopset1, stopset2);
        }
      P2SymBuild_BuildType ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lparatok)
    {
      /* avoid dangling else.  */
      Enumeration (stopset0, stopset1, stopset2);
      P2SymBuild_BuildType ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
    {
      /* avoid dangling else.  */
      SubrangeType (stopset0, stopset1, stopset2);
      P2SymBuild_BuildType ();
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%K[} {%K(} {%Kidentifier}", 44);
    }
}


/*
   Enumeration := '(' ( IdentList  ) ')' 
                  % StartBuildEnumeration ;  %
                  

   first  symbols:lparatok
   
   cannot reachend
*/

static void Enumeration (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_lparatok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  IdentList (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
  P2SymBuild_StartBuildEnumeration ();
}


/*
   IdentList := Ident 
                % VAR
                                                                                                  on: BOOLEAN ;
                                                                                                  n : CARDINAL ;  %
                
                % on := IsAutoPushOn() ;
                  IF on
                  THEN
                     n := 1
                  END  %
                { ',' Ident 
                  % IF on
                    THEN
                       INC(n)
                    END  %
                   } 
                % IF on
                  THEN
                     PushT(n)
                  END  %
                

   first  symbols:identtok
   
   cannot reachend
*/

static void IdentList (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  bool on;
  unsigned int n;

  Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
  on = M2Quads_IsAutoPushOn ();
  if (on)
    {
      n = 1;
    }
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
      if (on)
        {
          n += 1;
        }
    }
   /* while  */
  if (on)
    {
      M2Quads_PushT (n);
    }
}


/*
   SubrangeType := '[' ConstExpression '..' ConstExpression 
                   ']' 
                   % BuildSubrange(NulSym)  %
                   

   first  symbols:lsbratok
   
   cannot reachend
*/

static void SubrangeType (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_lsbratok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
  ConstExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_periodperiodtok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_periodperiodtok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
  ConstExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rsbratok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_rsbratok, stopset0, stopset1, stopset2);
  P2SymBuild_BuildSubrange (SymbolTable_NulSym);
}


/*
   PrefixedSubrangeType := '[' ConstExpression '..' 
                           ConstExpression ']' 
                           % VAR t: CARDINAL ;  %
                           
                           % PopT(t) ;
                             BuildSubrange(t)  %
                           

   first  symbols:lsbratok
   
   cannot reachend
*/

static void PrefixedSubrangeType (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  unsigned int t;

  Expect (M2Reserved_lsbratok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
  ConstExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_periodperiodtok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_periodperiodtok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
  ConstExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rsbratok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_rsbratok, stopset0, stopset1, stopset2);
  M2Quads_PopT (&t);
  P2SymBuild_BuildSubrange (t);
}


/*
   ArrayType := 'ARRAY' 
                % VAR arrayType, tok: CARDINAL ;  %
                
                % StartBuildArray ;
                  PopTtok(arrayType, tok) ;
                  PushTtok(arrayType, tok) ;
                  BuildNulName ;  %
                SimpleType 
                % BuildFieldArray ;  %
                { ',' 
                  % BuildArrayComma ;
                    BuildNulName ;  %
                  SimpleType 
                  % BuildFieldArray ;  %
                   } 'OF' 
                % BuildNulName ;  %
                Type 
                % EndBuildArray ;
                  PopNothing ;
                  PushTtok(arrayType, tok)  %
                

   first  symbols:arraytok
   
   cannot reachend
*/

static void ArrayType (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  unsigned int arrayType;
  unsigned int tok;

  Expect (M2Reserved_arraytok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  P2SymBuild_StartBuildArray ();
  M2Quads_PopTtok (&arrayType, &tok);
  M2Quads_PushTtok (arrayType, tok);
  P2SymBuild_BuildNulName ();
  SimpleType (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_oftok-M2Reserved_arraytok))), stopset2);
  P2SymBuild_BuildFieldArray ();
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      P2SymBuild_BuildArrayComma ();
      P2SymBuild_BuildNulName ();
      SimpleType (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_oftok-M2Reserved_arraytok))), stopset2);
      P2SymBuild_BuildFieldArray ();
    }
   /* while  */
  Expect (M2Reserved_oftok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_pointertok-M2Reserved_arraytok)) | (1 << (M2Reserved_packedsettok-M2Reserved_arraytok)) | (1 << (M2Reserved_oftok-M2Reserved_arraytok)) | (1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_settok-M2Reserved_recordtok)) | (1 << (M2Reserved_recordtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  P2SymBuild_BuildNulName ();
  Type (stopset0, stopset1, stopset2);
  P2SymBuild_EndBuildArray ();
  M2Quads_PopNothing ();
  M2Quads_PushTtok (arrayType, tok);
}


/*
   RecordType := 'RECORD' 
                 % BuildRecord  %
                 [ DefaultRecordAttributes  ] FieldListSequence 
                 'END' 

   first  symbols:recordtok
   
   cannot reachend
*/

static void RecordType (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_recordtok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok)) | (1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  P2SymBuild_BuildRecord ();
  if (M2LexBuf_currenttoken == M2Reserved_ldirectivetok)
    {
      DefaultRecordAttributes (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
    }
  FieldListSequence (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
  Expect (M2Reserved_endtok, stopset0, stopset1, stopset2);
}


/*
   DefaultRecordAttributes := '' 

   first  symbols:ldirectivetok
   
   cannot reachend
*/

static void DefaultRecordAttributes (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_ldirectivetok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Quads_PushAutoOn ();
  AttributeExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rdirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
  P2SymBuild_P2BuildDefaultFieldAlignment ();
  M2Quads_PopAuto ();
  Expect (M2Reserved_rdirectivetok, stopset0, stopset1, stopset2);
}


/*
   RecordFieldPragma := ( ''  | 
                          
                          % n := 0  %
                          
                          % PushT(n)  %
                          
                          % Annotate('(%1d)||pragma count')  %
                           ) 

   first  symbols:ldirectivetok
   
   reachend
*/

static void RecordFieldPragma (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  unsigned int n;

  if (M2LexBuf_currenttoken == M2Reserved_ldirectivetok)
    {
      Expect (M2Reserved_ldirectivetok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      FieldPragmaExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok)) | (1 << (M2Reserved_rdirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
      n = 1;
      M2Quads_PushT (n);
      M2Quads_Annotate ((const char *) "(%1d)||pragma count", 19);
      while (M2LexBuf_currenttoken == M2Reserved_commatok)
        {
          Expect (M2Reserved_commatok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
          M2Quads_PopT (&n);
          FieldPragmaExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rdirectivetok-M2Reserved_eoftok)) | (1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
          n += 1;
          M2Quads_PushT (n);
          M2Quads_Annotate ((const char *) "(%1d)||pragma count", 19);
        }
       /* while  */
      Expect (M2Reserved_rdirectivetok, stopset0, stopset1, stopset2);
    }
  else
    {
      n = 0;
      M2Quads_PushT (n);
      M2Quads_Annotate ((const char *) "(%1d)||pragma count", 19);
    }
}


/*
   FieldPragmaExpression := 
                            % PushAutoOn  %
                            Ident PragmaConstExpression 
                            
                            % PopAuto  %
                            

   first  symbols:identtok
   
   cannot reachend
*/

static void FieldPragmaExpression (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  M2Quads_PushAutoOn ();
  Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
  PragmaConstExpression (stopset0, stopset1, stopset2);
  M2Quads_PopAuto ();
}


/*
   PragmaConstExpression := ( 
                              % PushAutoOff  %
                              '(' ConstExpression 
                              % BuildPragmaConst  %
                              ')' 
                              % PopAuto  %
                               | 
                              
                              % PushT(NulSym)  %
                              
                              % Annotate('NulSym||no pragma const')  %
                               ) 

   first  symbols:lparatok
   
   reachend
*/

static void PragmaConstExpression (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_lparatok)
    {
      Expect (M2Reserved_lparatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      M2Quads_PushAutoOff ();
      ConstExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
      P2SymBuild_BuildPragmaConst ();
      Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
      M2Quads_PopAuto ();
    }
  else
    {
      M2Quads_PushT (static_cast<unsigned int> (SymbolTable_NulSym));
      M2Quads_Annotate ((const char *) "NulSym||no pragma const", 23);
    }
}


/*
   AttributeExpression := Ident '(' ConstExpression 
                          ')' 

   first  symbols:identtok
   
   cannot reachend
*/

static void AttributeExpression (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_lparatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
  ConstExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
}


/*
   FieldListSequence := FieldListStatement { ';' FieldListStatement  } 

   first  symbols:casetok, identtok, semicolontok
   
   reachend
*/

static void FieldListSequence (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  FieldListStatement (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
  while (M2LexBuf_currenttoken == M2Reserved_semicolontok)
    {
      Expect (M2Reserved_semicolontok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_casetok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      FieldListStatement (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
    }
   /* while  */
}


/*
   FieldListStatement := [ FieldList  ] 

   first  symbols:identtok, casetok
   
   reachend
*/

static void FieldListStatement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if ((M2LexBuf_currenttoken == M2Reserved_casetok) || (M2LexBuf_currenttoken == M2Reserved_identtok))
    {
      FieldList (stopset0, stopset1, stopset2);
    }
}


/*
   FieldList := IdentList ':' 
                % BuildNulName  %
                Type RecordFieldPragma 
                % BuildFieldRecord  %
                 | 
                'CASE' 
                % AddRecordToList  %
                
                % StartBuildVarient  %
                
                % AddVarientToList  %
                CaseTag 'OF' Varient { '|' Varient  } 
                [ 'ELSE' 
                  % StartBuildVarientFieldRecord  %
                  FieldListSequence 
                  % EndBuildVarientFieldRecord  %
                   ] 'END' 
                % EndBuildVarient  %
                

   first  symbols:casetok, identtok
   
   cannot reachend
*/

static void FieldList (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_identtok)
    {
      IdentList (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_colontok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_pointertok-M2Reserved_arraytok)) | (1 << (M2Reserved_packedsettok-M2Reserved_arraytok)) | (1 << (M2Reserved_oftok-M2Reserved_arraytok)) | (1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_settok-M2Reserved_recordtok)) | (1 << (M2Reserved_recordtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      P2SymBuild_BuildNulName ();
      Type (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
      RecordFieldPragma (stopset0, stopset1, stopset2);
      P2SymBuild_BuildFieldRecord ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_casetok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_casetok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_oftok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      M2Quads_AddRecordToList ();
      P2SymBuild_StartBuildVarient ();
      M2Quads_AddVarientToList ();
      CaseTag (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_oftok-M2Reserved_arraytok))), stopset2);
      Expect (M2Reserved_oftok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_bartok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_elsetok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
      Varient (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_bartok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_elsetok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
      while (M2LexBuf_currenttoken == M2Reserved_bartok)
        {
          Expect (M2Reserved_bartok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_bartok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_elsetok-M2Reserved_arraytok)) | (1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
          Varient (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_bartok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_elsetok-M2Reserved_arraytok))), stopset2);
        }
       /* while  */
      if (M2LexBuf_currenttoken == M2Reserved_elsetok)
        {
          Expect (M2Reserved_elsetok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
          P2SymBuild_StartBuildVarientFieldRecord ();
          FieldListSequence (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
          P2SymBuild_EndBuildVarientFieldRecord ();
        }
      Expect (M2Reserved_endtok, stopset0, stopset1, stopset2);
      P2SymBuild_EndBuildVarient ();
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KCASE} {%Kidentifier}", 41);
    }
}


/*
   TagIdent := Ident  | 
               % BuildNulName  %
               

   first  symbols:identtok
   
   reachend
*/

static void TagIdent (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_identtok)
    {
      Ident (stopset0, stopset1, stopset2);
    }
  else
    {
      P2SymBuild_BuildNulName ();
    }
}


/*
   CaseTag := TagIdent ( ':' Qualident  | 
                         
                         % PushT(NulSym)  %
                          ) 
              % BuildVarientSelector  %
              

   first  symbols:colontok, identtok
   
   reachend
*/

static void CaseTag (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  TagIdent (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_colontok)
    {
      Expect (M2Reserved_colontok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Qualident (stopset0, stopset1, stopset2);
    }
  else
    {
      M2Quads_PushT (static_cast<unsigned int> (SymbolTable_NulSym));
    }
  P2SymBuild_BuildVarientSelector ();
}


/*
   Varient := [ 
                % StartBuildVarientFieldRecord  %
                VarientCaseLabelList ':' FieldListSequence 
                
                % EndBuildVarientFieldRecord  %
                 ] 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   reachend
*/

static void Varient (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_nottok)) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))))) != 0))))
    {
      P2SymBuild_StartBuildVarientFieldRecord ();
      VarientCaseLabelList (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_colontok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_casetok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      FieldListSequence (stopset0, stopset1, stopset2);
      P2SymBuild_EndBuildVarientFieldRecord ();
    }
}


/*
   VarientCaseLabelList := VarientCaseLabels { ',' 
                                               VarientCaseLabels  } 

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void VarientCaseLabelList (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  VarientCaseLabels (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
      VarientCaseLabels (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
   /* while  */
}


/*
   VarientCaseLabels := ConstExpression [ '..' ConstExpression  ] 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void VarientCaseLabels (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  ConstExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_periodperiodtok-M2Reserved_eoftok))), stopset1, stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_periodperiodtok)
    {
      Expect (M2Reserved_periodperiodtok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      ConstExpression (stopset0, stopset1, stopset2);
    }
}


/*
   CaseLabelList := CaseLabels { ',' CaseLabels  } 

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void CaseLabelList (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  CaseLabels (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
      CaseLabels (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
   /* while  */
}


/*
   CaseLabels := ConstExpression [ '..' ConstExpression  ] 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void CaseLabels (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  ConstExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_periodperiodtok-M2Reserved_eoftok))), stopset1, stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_periodperiodtok)
    {
      Expect (M2Reserved_periodperiodtok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      ConstExpression (stopset0, stopset1, stopset2);
    }
}


/*
   SetType := 
              % VAR ispacked: BOOLEAN ;
                    setpos  : CARDINAL ;  %
              
              % setpos := GetTokenNo ()  %
              
              % ispacked := FALSE  %
              ( 'SET' 
                % ispacked := FALSE  %
                 | 'PACKEDSET' 
                % ispacked := TRUE  %
                 ) 'OF' 
              % BuildNulName  %
              SimpleType 
              % BuildSetType (setpos, ispacked)  %
              

   first  symbols:oftok, packedsettok, settok
   
   cannot reachend
*/

static void SetType (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  bool ispacked;
  unsigned int setpos;

  setpos = M2LexBuf_GetTokenNo ();
  ispacked = false;
  if (M2LexBuf_currenttoken == M2Reserved_settok)
    {
      Expect (M2Reserved_settok, stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_oftok-M2Reserved_arraytok))), stopset2);
      ispacked = false;
    }
  else if (M2LexBuf_currenttoken == M2Reserved_packedsettok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_packedsettok, stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_oftok-M2Reserved_arraytok))), stopset2);
      ispacked = true;
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KPACKEDSET} {%KSET}", 39);
    }
  Expect (M2Reserved_oftok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  P2SymBuild_BuildNulName ();
  SimpleType (stopset0, stopset1, stopset2);
  P2SymBuild_BuildSetType (setpos, ispacked);
}


/*
   PointerType := 
                  % VAR pointerpos: CARDINAL ;  %
                  
                  % pointerpos := GetTokenNo ()  %
                  'POINTER' 'TO' 
                  % BuildNulName  %
                  Type 
                  % BuildPointerType (pointerpos)  %
                  

   first  symbols:pointertok
   
   cannot reachend
*/

static void PointerType (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  unsigned int pointerpos;

  pointerpos = M2LexBuf_GetTokenNo ();
  Expect (M2Reserved_pointertok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_totok-M2Reserved_recordtok))));
  Expect (M2Reserved_totok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_pointertok-M2Reserved_arraytok)) | (1 << (M2Reserved_packedsettok-M2Reserved_arraytok)) | (1 << (M2Reserved_oftok-M2Reserved_arraytok)) | (1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_settok-M2Reserved_recordtok)) | (1 << (M2Reserved_recordtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  P2SymBuild_BuildNulName ();
  Type (stopset0, stopset1, stopset2);
  P2SymBuild_BuildPointerType (pointerpos);
}


/*
   ProcedureType := 'PROCEDURE' 
                    % BuildProcedureType ;  %
                    [ FormalTypeList  ] 

   first  symbols:proceduretok
   
   cannot reachend
*/

static void ProcedureType (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_proceduretok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
  P2SymBuild_BuildProcedureType ();
  if (M2LexBuf_currenttoken == M2Reserved_lparatok)
    {
      FormalTypeList (stopset0, stopset1, stopset2);
    }
}


/*
   FormalTypeList := '(' ( ')' FormalReturn  | 
                           ProcedureParameters ')' 
                           FormalReturn  ) 

   first  symbols:lparatok
   
   cannot reachend
*/

static void FormalTypeList (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_lparatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_periodperiodperiodtok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  if (M2LexBuf_currenttoken == M2Reserved_rparatok)
    {
      Expect (M2Reserved_rparatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
      FormalReturn (stopset0, stopset1, stopset2);
    }
  else if ((M2LexBuf_currenttoken == M2Reserved_arraytok) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_vartok-M2Reserved_recordtok)) | (1 << (M2Reserved_periodperiodperiodtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))))) != 0))))
    {
      /* avoid dangling else.  */
      ProcedureParameters (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_rparatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
      FormalReturn (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KVAR} {%K...} {%KARRAY} {%Kidentifier} {%K)}", 64);
    }
}


/*
   FormalReturn := [ ':' OptReturnType  ] 

   first  symbols:colontok
   
   reachend
*/

static void FormalReturn (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_colontok)
    {
      Expect (M2Reserved_colontok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      OptReturnType (stopset0, stopset1, stopset2);
    }
}


/*
   OptReturnType := '[' Qualident 
                    % BuildOptFunction  %
                    ']'  | Qualident 
                    % BuildFunction  %
                    

   first  symbols:identtok, lsbratok
   
   cannot reachend
*/

static void OptReturnType (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
    {
      Expect (M2Reserved_lsbratok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Qualident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rsbratok-M2Reserved_eoftok))), stopset1, stopset2);
      P2SymBuild_BuildOptFunction ();
      Expect (M2Reserved_rsbratok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_identtok)
    {
      /* avoid dangling else.  */
      Qualident (stopset0, stopset1, stopset2);
      P2SymBuild_BuildFunction ();
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%Kidentifier} {%K[}", 38);
    }
}


/*
   ProcedureParameters := ProcedureParameter { ',' 
                                               ProcedureParameter  } 

   first  symbols:identtok, arraytok, periodperiodperiodtok, vartok
   
   cannot reachend
*/

static void ProcedureParameters (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  ProcedureParameter (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_vartok-M2Reserved_recordtok)) | (1 << (M2Reserved_periodperiodperiodtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      ProcedureParameter (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
   /* while  */
}


/*
   ProcedureParameter := '...' 
                         % BuildFormalVarArgs  %
                          | 'VAR' 
                         % PushT(VarTok) ;  %
                         FormalType 
                         % BuildFormalType ;  %
                          | 
                         % PushT(NulTok) ;  %
                         FormalType 
                         % BuildFormalType ;  %
                         

   first  symbols:arraytok, identtok, vartok, periodperiodperiodtok
   
   cannot reachend
*/

static void ProcedureParameter (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_periodperiodperiodtok)
    {
      Expect (M2Reserved_periodperiodperiodtok, stopset0, stopset1, stopset2);
      P2SymBuild_BuildFormalVarArgs ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_vartok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_vartok, stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      M2Quads_PushT (M2Reserved_VarTok);
      FormalType (stopset0, stopset1, stopset2);
      P2SymBuild_BuildFormalType ();
    }
  else
    {
      /* avoid dangling else.  */
      M2Quads_PushT (M2Reserved_NulTok);
      FormalType (stopset0, stopset1, stopset2);
      P2SymBuild_BuildFormalType ();
    }
}


/*
   VarIdent := Ident 
               % VAR
                                                                                                 on            : BOOLEAN ;
                                                                                                 Sym, Type, tok: CARDINAL ;  %
               [ '[' 
                 % on := IsAutoPushOn() ;
                   IF on
                   THEN
                      PopTFtok(Sym, Type, tok) ;
                      PushTFAtok(Sym, Type, Sym, tok)
                   END  %
                 ConstExpression ']'  ] 

   first  symbols:identtok
   
   cannot reachend
*/

static void VarIdent (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  bool on;
  unsigned int Sym;
  unsigned int Type;
  unsigned int tok;

  Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
    {
      Expect (M2Reserved_lsbratok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      on = M2Quads_IsAutoPushOn ();
      if (on)
        {
          M2Quads_PopTFtok (&Sym, &Type, &tok);
          M2Quads_PushTFAtok (Sym, Type, Sym, tok);
        }
      ConstExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rsbratok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_rsbratok, stopset0, stopset1, stopset2);
    }
}


/*
   VarIdentList := VarIdent 
                   % VAR
                                                                                                     on: BOOLEAN ;
                                                                                                     n : CARDINAL ;  %
                   
                   % on := IsAutoPushOn() ;
                     IF on
                     THEN
                        n := 1
                     END  %
                   { ',' VarIdent 
                     % IF on
                       THEN
                          INC(n)
                       END  %
                      } 
                   % IF on
                     THEN
                        PushT(n)
                     END  %
                   

   first  symbols:identtok
   
   cannot reachend
*/

static void VarIdentList (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  bool on;
  unsigned int n;

  VarIdent (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
  on = M2Quads_IsAutoPushOn ();
  if (on)
    {
      n = 1;
    }
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      VarIdent (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
      if (on)
        {
          n += 1;
        }
    }
   /* while  */
  if (on)
    {
      M2Quads_PushT (n);
    }
}


/*
   VariableDeclaration := VarIdentList ':' 
                          % BuildNulName  %
                          
                          % DisplayStack  %
                          Type 
                          % DisplayStack  %
                          Alignment 
                          % DisplayStack  %
                          
                          % BuildVarAlignment  %
                          
                          % DisplayStack  %
                          
                          % BuildVariable  %
                          

   first  symbols:identtok
   
   cannot reachend
*/

static void VariableDeclaration (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  VarIdentList (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_colontok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_pointertok-M2Reserved_arraytok)) | (1 << (M2Reserved_packedsettok-M2Reserved_arraytok)) | (1 << (M2Reserved_oftok-M2Reserved_arraytok)) | (1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_settok-M2Reserved_recordtok)) | (1 << (M2Reserved_recordtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  P2SymBuild_BuildNulName ();
  M2Quads_DisplayStack ();
  Type (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
  M2Quads_DisplayStack ();
  Alignment (stopset0, stopset1, stopset2);
  M2Quads_DisplayStack ();
  P2SymBuild_BuildVarAlignment ();
  M2Quads_DisplayStack ();
  P2SymBuild_BuildVariable ();
}


/*
   Designator := Qualident { SubDesignator  } 

   first  symbols:identtok
   
   cannot reachend
*/

static void Designator (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Qualident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_uparrowtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_periodtok-M2Reserved_eoftok))), stopset1, stopset2);
  while ((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_periodtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_uparrowtok-M2Reserved_eoftok))))) != 0)))
    {
      SubDesignator (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_periodtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_uparrowtok-M2Reserved_eoftok))), stopset1, stopset2);
    }
   /* while  */
}


/*
   SubDesignator := '.' Ident  | '[' ExpList ']'  | 
                    '^' 

   first  symbols:uparrowtok, lsbratok, periodtok
   
   cannot reachend
*/

static void SubDesignator (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_periodtok)
    {
      Expect (M2Reserved_periodtok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Ident (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_lsbratok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      ExpList (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rsbratok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_rsbratok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_uparrowtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_uparrowtok, stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%K^} {%K[} {%K.}", 35);
    }
}


/*
   ExpList := Expression { ',' Expression  } 

   first  symbols:lcbratok, identtok, realtok, integertok, stringtok, lparatok, nottok, attributetok, plustok, minustok
   
   cannot reachend
*/

static void ExpList (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Expression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
   /* while  */
}


/*
   Expression := 
                 % PushType ; SeenUnknown ; PushAutoOff  %
                 SimpleExpression [ Relation SimpleExpression  ] 
                 
                 % PopAuto ; PopType  %
                 

   first  symbols:identtok, lcbratok, attributetok, nottok, lparatok, stringtok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void Expression (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  P2SymBuild_PushType ();
  P2SymBuild_SeenUnknown ();
  M2Quads_PushAutoOff ();
  SimpleExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_greaterequaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_greatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessequaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_lesstok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessgreatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_hashtok-M2Reserved_eoftok)) | (1 << (M2Reserved_equaltok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_intok-M2Reserved_arraytok))), stopset2);
  if (((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_equaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_hashtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessgreatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_lesstok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessequaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_greatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_greaterequaltok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_intok))
    {
      Relation (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      SimpleExpression (stopset0, stopset1, stopset2);
    }
  M2Quads_PopAuto ();
  P2SymBuild_PopType ();
}


/*
   SimpleExpression := UnaryOrTerm { AddOperator Term  } 

   first  symbols:lcbratok, identtok, realtok, integertok, stringtok, lparatok, nottok, attributetok, plustok, minustok
   
   cannot reachend
*/

static void SimpleExpression (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  UnaryOrTerm (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_ortok-M2Reserved_arraytok))), stopset2);
  while (((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_ortok))
    {
      AddOperator (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Term (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_ortok-M2Reserved_arraytok))), stopset2);
    }
   /* while  */
}


/*
   UnaryOrTerm := '+' Term  | '-' Term  | 
                  Term 

   first  symbols:identtok, lcbratok, attributetok, nottok, lparatok, stringtok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void UnaryOrTerm (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_plustok)
    {
      Expect (M2Reserved_plustok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Term (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_minustok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_minustok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Term (stopset0, stopset1, stopset2);
    }
  else if ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_nottok)) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))))) != 0))))
    {
      /* avoid dangling else.  */
      Term (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%K__ATTRIBUTE__} {%KNOT} {%K(} {%Kstring} {%Kinteger number} {%Kreal number} {%Kidentifier} {%K%{} {%K-} {%K+}", 129);
    }
}


/*
   Term := Factor { MulOperator Factor  } 

   first  symbols:lcbratok, identtok, realtok, integertok, stringtok, lparatok, nottok, attributetok
   
   cannot reachend
*/

static void Term (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Factor (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_ambersandtok-M2Reserved_eoftok)) | (1 << (M2Reserved_andtok-M2Reserved_eoftok)) | (1 << (M2Reserved_dividetok-M2Reserved_eoftok)) | (1 << (M2Reserved_timestok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_modtok-M2Reserved_arraytok)) | (1 << (M2Reserved_divtok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_remtok-M2Reserved_recordtok))));
  while ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_timestok-M2Reserved_eoftok)) | (1 << (M2Reserved_dividetok-M2Reserved_eoftok)) | (1 << (M2Reserved_andtok-M2Reserved_eoftok)) | (1 << (M2Reserved_ambersandtok-M2Reserved_eoftok))))) != 0))) || (((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P2Build_SetOfStop1) ((1 << (M2Reserved_divtok-M2Reserved_arraytok)) | (1 << (M2Reserved_modtok-M2Reserved_arraytok))))) != 0)))) || (M2LexBuf_currenttoken == M2Reserved_remtok))
    {
      MulOperator (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Factor (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_timestok-M2Reserved_eoftok)) | (1 << (M2Reserved_dividetok-M2Reserved_eoftok)) | (1 << (M2Reserved_andtok-M2Reserved_eoftok)) | (1 << (M2Reserved_ambersandtok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_divtok-M2Reserved_arraytok)) | (1 << (M2Reserved_modtok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_remtok-M2Reserved_recordtok))));
    }
   /* while  */
}


/*
   Factor := Number  | string  | SetOrDesignatorOrFunction  | 
             '(' Expression ')'  | 
             'NOT' Factor  | ConstAttribute 

   first  symbols:identtok, lcbratok, attributetok, nottok, lparatok, stringtok, integertok, realtok
   
   cannot reachend
*/

static void Factor (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok))))) != 0)))
    {
      Number (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_stringtok)
    {
      /* avoid dangling else.  */
      string (stopset0, stopset1, stopset2);
    }
  else if ((M2LexBuf_currenttoken == M2Reserved_lcbratok) || (M2LexBuf_currenttoken == M2Reserved_identtok))
    {
      /* avoid dangling else.  */
      SetOrDesignatorOrFunction (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lparatok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_lparatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Expression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_nottok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_nottok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Factor (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_attributetok)
    {
      /* avoid dangling else.  */
      ConstAttribute (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%K__ATTRIBUTE__} {%KNOT} {%K(} {%Kidentifier} {%K%{} {%Kstring} {%Kinteger number} {%Kreal number}", 117);
    }
}


/*
   SetOrDesignatorOrFunction := ( Qualident [ Constructor  | 
                                              SimpleDes 
                                              [ ActualParameters  ]  ]  | 
                                  Constructor  ) 

   first  symbols:lcbratok, identtok
   
   cannot reachend
*/

static void SetOrDesignatorOrFunction (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_identtok)
    {
      /* avoid dangling else.  */
      Qualident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lcbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_uparrowtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_periodtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
      if ((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_periodtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_uparrowtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0)))
        {
          /* avoid gcc warning by using compound statement even if not strictly necessary.  */
          /* seen optional [ | ] expression  */
          if (M2LexBuf_currenttoken == M2Reserved_lcbratok)
            {
              Constructor (stopset0, stopset1, stopset2);
            }
          else if ((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_periodtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_uparrowtok-M2Reserved_eoftok))))) != 0)))
            {
              /* avoid dangling else.  */
              SimpleDes (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
              if (M2LexBuf_currenttoken == M2Reserved_lparatok)
                {
                  ActualParameters (stopset0, stopset1, stopset2);
                }
            }
          else
            {
              /* avoid dangling else.  */
              ErrorArray ((const char *) "expecting one of: {%K(} {%K.} {%K[} {%K^} {%K%{}", 48);
            }
        }
      /* end of optional [ | ] expression  */
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lcbratok)
    {
      /* avoid dangling else.  */
      Constructor (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%K%{} {%Kidentifier}", 39);
    }
}


/*
   SimpleDes := { '.' Ident  | '[' ExpList ']'  | 
                  '^'  } 

   first  symbols:uparrowtok, lsbratok, periodtok
   
   reachend
*/

static void SimpleDes (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if ((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_uparrowtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_periodtok-M2Reserved_eoftok))))) != 0)))
    {
      /* seen optional { | } expression  */
      while ((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_uparrowtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_periodtok-M2Reserved_eoftok))))) != 0)))
        {
          if (M2LexBuf_currenttoken == M2Reserved_periodtok)
            {
              Expect (M2Reserved_periodtok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
              Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_uparrowtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_periodtok-M2Reserved_eoftok))), stopset1, stopset2);
            }
          else if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
            {
              /* avoid dangling else.  */
              Expect (M2Reserved_lsbratok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
              ExpList (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rsbratok-M2Reserved_eoftok))), stopset1, stopset2);
              Expect (M2Reserved_rsbratok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_uparrowtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_periodtok-M2Reserved_eoftok))), stopset1, stopset2);
            }
          else if (M2LexBuf_currenttoken == M2Reserved_uparrowtok)
            {
              /* avoid dangling else.  */
              Expect (M2Reserved_uparrowtok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_uparrowtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_periodtok-M2Reserved_eoftok))), stopset1, stopset2);
            }
        }
      /* end of optional { | } expression  */
    }
}


/*
   ActualParameters := '(' [ ExpList  ] ')' 

   first  symbols:lparatok
   
   cannot reachend
*/

static void ActualParameters (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_lparatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  if ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_nottok)) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))))) != 0))))
    {
      ExpList (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
}


/*
   Statement := 
                % PushAutoOff ;  %
                [ AssignmentOrProcedureCall  | 
                  IfStatement  | CaseStatement  | 
                  WhileStatement  | 
                  RepeatStatement  | 
                  LoopStatement  | ForStatement  | 
                  WithStatement  | AsmStatement  | 
                  'EXIT'  | 'RETURN' [ Expression  ]  | 
                  RetryStatement  ] 
                % PopAuto ;  %
                

   first  symbols:retrytok, asmtok, withtok, fortok, looptok, repeattok, whiletok, casetok, iftok, identtok, returntok, exittok
   
   reachend
*/

static void Statement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  M2Quads_PushAutoOff ();
  if ((((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P2Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok))))) != 0))) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_retrytok-M2Reserved_recordtok)) | (1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))))) != 0))))
    {
      /* avoid gcc warning by using compound statement even if not strictly necessary.  */
      /* seen optional [ | ] expression  */
      if (M2LexBuf_currenttoken == M2Reserved_identtok)
        {
          AssignmentOrProcedureCall (stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_iftok)
        {
          /* avoid dangling else.  */
          IfStatement (stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_casetok)
        {
          /* avoid dangling else.  */
          CaseStatement (stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_whiletok)
        {
          /* avoid dangling else.  */
          WhileStatement (stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_repeattok)
        {
          /* avoid dangling else.  */
          RepeatStatement (stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_looptok)
        {
          /* avoid dangling else.  */
          LoopStatement (stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_fortok)
        {
          /* avoid dangling else.  */
          ForStatement (stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_withtok)
        {
          /* avoid dangling else.  */
          WithStatement (stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_asmtok)
        {
          /* avoid dangling else.  */
          AsmStatement (stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_exittok)
        {
          /* avoid dangling else.  */
          Expect (M2Reserved_exittok, stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_returntok)
        {
          /* avoid dangling else.  */
          Expect (M2Reserved_returntok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
          if ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_nottok)) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))))) != 0))))
            {
              Expression (stopset0, stopset1, stopset2);
            }
        }
      else if (M2LexBuf_currenttoken == M2Reserved_retrytok)
        {
          /* avoid dangling else.  */
          RetryStatement (stopset0, stopset1, stopset2);
        }
      else
        {
          /* avoid dangling else.  */
          ErrorArray ((const char *) "expecting one of: {%KRETRY} {%KRETURN} {%KEXIT} {%KASM} {%KWITH} {%KFOR} {%KLOOP} {%KREPEAT} {%KWHILE} {%KCASE} {%KIF} {%Kidentifier}", 133);
        }
    }
  /* end of optional [ | ] expression  */
  M2Quads_PopAuto ();
}


/*
   RetryStatement := 'RETRY' 

   first  symbols:retrytok
   
   cannot reachend
*/

static void RetryStatement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_retrytok, stopset0, stopset1, stopset2);
}


/*
   AssignmentOrProcedureCall := Designator ( ':=' Expression  | 
                                             ActualParameters  | 
                                             
                                             %  epsilon   %
                                              ) 

   first  symbols:identtok
   
   cannot reachend
*/

static void AssignmentOrProcedureCall (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Designator (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_becomestok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_becomestok)
    {
      Expect (M2Reserved_becomestok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Expression (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lparatok)
    {
      /* avoid dangling else.  */
      ActualParameters (stopset0, stopset1, stopset2);
    }
  /* epsilon  */
}


/*
   StatementSequence := Statement { ';' Statement  } 

   first  symbols:identtok, iftok, casetok, whiletok, repeattok, looptok, fortok, withtok, asmtok, retrytok, semicolontok, exittok, returntok
   
   reachend
*/

static void StatementSequence (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Statement (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
  while (M2LexBuf_currenttoken == M2Reserved_semicolontok)
    {
      Expect (M2Reserved_semicolontok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Statement (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
    }
   /* while  */
}


/*
   IfStatement := 'IF' Expression 'THEN' StatementSequence 
                  { 'ELSIF' Expression 'THEN' StatementSequence  } 
                  [ 'ELSE' StatementSequence  ] 'END' 

   first  symbols:iftok
   
   cannot reachend
*/

static void IfStatement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_iftok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Expression (stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_thentok-M2Reserved_recordtok))));
  Expect (M2Reserved_thentok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_elsiftok-M2Reserved_arraytok)) | (1 << (M2Reserved_elsetok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
  StatementSequence (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_elsiftok-M2Reserved_arraytok)) | (1 << (M2Reserved_elsetok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
  while (M2LexBuf_currenttoken == M2Reserved_elsiftok)
    {
      Expect (M2Reserved_elsiftok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Expression (stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_thentok-M2Reserved_recordtok))));
      Expect (M2Reserved_thentok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_elsetok-M2Reserved_arraytok)) | (1 << (M2Reserved_elsiftok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
      StatementSequence (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_elsetok-M2Reserved_arraytok)) | (1 << (M2Reserved_elsiftok-M2Reserved_arraytok))), stopset2);
    }
   /* while  */
  if (M2LexBuf_currenttoken == M2Reserved_elsetok)
    {
      Expect (M2Reserved_elsetok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
      StatementSequence (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
    }
  Expect (M2Reserved_endtok, stopset0, stopset1, stopset2);
}


/*
   CaseStatement := 'CASE' Expression 'OF' Case { '|' 
                                                  Case  } 
                    [ 'ELSE' StatementSequence  ] 'END' 

   first  symbols:casetok
   
   cannot reachend
*/

static void CaseStatement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_casetok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Expression (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_oftok-M2Reserved_arraytok))), stopset2);
  Expect (M2Reserved_oftok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_bartok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_elsetok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
  Case (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_bartok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_elsetok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
  while (M2LexBuf_currenttoken == M2Reserved_bartok)
    {
      Expect (M2Reserved_bartok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_bartok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_elsetok-M2Reserved_arraytok)) | (1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
      Case (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_bartok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_elsetok-M2Reserved_arraytok))), stopset2);
    }
   /* while  */
  if (M2LexBuf_currenttoken == M2Reserved_elsetok)
    {
      Expect (M2Reserved_elsetok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
      StatementSequence (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
    }
  Expect (M2Reserved_endtok, stopset0, stopset1, stopset2);
}


/*
   Case := [ CaseLabelList ':' StatementSequence  ] 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   reachend
*/

static void Case (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_nottok)) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))))) != 0))))
    {
      CaseLabelList (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_colontok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
      StatementSequence (stopset0, stopset1, stopset2);
    }
}


/*
   WhileStatement := 'WHILE' Expression 'DO' StatementSequence 
                     'END' 

   first  symbols:whiletok
   
   cannot reachend
*/

static void WhileStatement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_whiletok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Expression (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_dotok-M2Reserved_arraytok))), stopset2);
  Expect (M2Reserved_dotok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
  StatementSequence (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
  Expect (M2Reserved_endtok, stopset0, stopset1, stopset2);
}


/*
   RepeatStatement := 'REPEAT' StatementSequence 'UNTIL' 
                      Expression 

   first  symbols:repeattok
   
   cannot reachend
*/

static void RepeatStatement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_repeattok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_untiltok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
  StatementSequence (stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_untiltok-M2Reserved_recordtok))));
  Expect (M2Reserved_untiltok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Expression (stopset0, stopset1, stopset2);
}


/*
   ForStatement := 'FOR' Ident ':=' Expression 'TO' 
                   Expression [ 'BY' ConstExpression  ] 
                   'DO' StatementSequence 'END' 

   first  symbols:fortok
   
   cannot reachend
*/

static void ForStatement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_fortok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_becomestok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_becomestok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Expression (stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_totok-M2Reserved_recordtok))));
  Expect (M2Reserved_totok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Expression (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_bytok-M2Reserved_arraytok)) | (1 << (M2Reserved_dotok-M2Reserved_arraytok))), stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_bytok)
    {
      Expect (M2Reserved_bytok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      ConstExpression (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_dotok-M2Reserved_arraytok))), stopset2);
    }
  Expect (M2Reserved_dotok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
  StatementSequence (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
  Expect (M2Reserved_endtok, stopset0, stopset1, stopset2);
}


/*
   LoopStatement := 'LOOP' StatementSequence 'END' 

   first  symbols:looptok
   
   cannot reachend
*/

static void LoopStatement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_looptok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
  StatementSequence (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
  Expect (M2Reserved_endtok, stopset0, stopset1, stopset2);
}


/*
   WithStatement := 'WITH' Designator 'DO' StatementSequence 
                    'END' 

   first  symbols:withtok
   
   cannot reachend
*/

static void WithStatement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_withtok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Designator (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_dotok-M2Reserved_arraytok))), stopset2);
  Expect (M2Reserved_dotok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
  StatementSequence (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
  Expect (M2Reserved_endtok, stopset0, stopset1, stopset2);
}


/*
   ProcedureDeclaration := ProcedureHeading 
                           % Assert(IsProcedure(OperandT(1)))  %
                           ';' ( ProcedureBlock 
                                 % Assert(IsProcedure(OperandT(1)))  %
                                 Ident  ) 
                           % EndBuildProcedure  %
                           

   first  symbols:proceduretok
   
   cannot reachend
*/

static void ProcedureDeclaration (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  ProcedureHeading (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
  M2Debug_Assert (SymbolTable_IsProcedure (M2Quads_OperandT (1)));
  Expect (M2Reserved_semicolontok, stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_begintok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
  ProcedureBlock (stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Debug_Assert (SymbolTable_IsProcedure (M2Quads_OperandT (1)));
  Ident (stopset0, stopset1, stopset2);
  P2SymBuild_EndBuildProcedure ();
}


/*
   DefineBuiltinProcedure := [ '__ATTRIBUTE__' '__BUILTIN__' 
                               '(' '(' 
                               % PushAutoOff  %
                               Ident 
                               % PopAuto  %
                               ')' ')'  | 
                               '__INLINE__'  ] 

   first  symbols:inlinetok, attributetok
   
   reachend
*/

static void DefineBuiltinProcedure (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_inlinetok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))))) != 0)))
    {
      /* avoid gcc warning by using compound statement even if not strictly necessary.  */
      /* seen optional [ | ] expression  */
      if (M2LexBuf_currenttoken == M2Reserved_attributetok)
        {
          Expect (M2Reserved_attributetok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_builtintok-M2Reserved_recordtok))));
          Expect (M2Reserved_builtintok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
          Expect (M2Reserved_lparatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
          Expect (M2Reserved_lparatok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
          M2Quads_PushAutoOff ();
          Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
          M2Quads_PopAuto ();
          Expect (M2Reserved_rparatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
          Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_inlinetok)
        {
          /* avoid dangling else.  */
          Expect (M2Reserved_inlinetok, stopset0, stopset1, stopset2);
        }
      else
        {
          /* avoid dangling else.  */
          ErrorArray ((const char *) "expecting one of: {%K__INLINE__} {%K__ATTRIBUTE__}", 50);
        }
    }
  /* end of optional [ | ] expression  */
}


/*
   ProcedureHeading := 'PROCEDURE' 
                       % M2Error.DefaultProcedure  %
                       DefineBuiltinProcedure ( Ident 
                                                
                                                % StartBuildProcedure  %
                                                
                                                % Assert(IsProcedure(OperandT(1)))  %
                                                
                                                % StartBuildFormalParameters   %
                                                [ FormalParameters  ] 
                                                
                                                % EndBuildFormalParameters  %
                                                AttributeNoReturn 
                                                
                                                % BuildProcedureHeading  %
                                                 ) 

   first  symbols:proceduretok
   
   cannot reachend
*/

static void ProcedureHeading (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_proceduretok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_inlinetok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Error_DefaultProcedure ();
  DefineBuiltinProcedure (stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
  P2SymBuild_StartBuildProcedure ();
  M2Debug_Assert (SymbolTable_IsProcedure (M2Quads_OperandT (1)));
  P2SymBuild_StartBuildFormalParameters ();
  if (M2LexBuf_currenttoken == M2Reserved_lparatok)
    {
      FormalParameters (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  P2SymBuild_EndBuildFormalParameters ();
  AttributeNoReturn (stopset0, stopset1, stopset2);
  P2SymBuild_BuildProcedureHeading ();
}


/*
   Builtin := [ '__BUILTIN__'  | '__INLINE__'  ] 

   first  symbols:inlinetok, builtintok
   
   reachend
*/

static void Builtin (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_inlinetok-M2Reserved_recordtok)) | (1 << (M2Reserved_builtintok-M2Reserved_recordtok))))) != 0)))
    {
      /* avoid gcc warning by using compound statement even if not strictly necessary.  */
      /* seen optional [ | ] expression  */
      if (M2LexBuf_currenttoken == M2Reserved_builtintok)
        {
          Expect (M2Reserved_builtintok, stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_inlinetok)
        {
          /* avoid dangling else.  */
          Expect (M2Reserved_inlinetok, stopset0, stopset1, stopset2);
        }
      else
        {
          /* avoid dangling else.  */
          ErrorArray ((const char *) "expecting one of: {%K__INLINE__} {%K__BUILTIN__}", 48);
        }
    }
  /* end of optional [ | ] expression  */
}


/*
   DefProcedureHeading := 'PROCEDURE' 
                          % M2Error.DefaultProcedure  %
                          Builtin ( Ident 
                                    % StartBuildProcedure  %
                                    
                                    % Assert(IsProcedure(OperandT(1)))  %
                                    
                                    % StartBuildFormalParameters   %
                                    [ DefFormalParameters  ] 
                                    
                                    % EndBuildFormalParameters  %
                                    AttributeNoReturn 
                                    
                                    % BuildProcedureHeading  %
                                     ) 
                          % M2Error.LeaveErrorScope  %
                          

   first  symbols:proceduretok
   
   cannot reachend
*/

static void DefProcedureHeading (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_proceduretok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_inlinetok-M2Reserved_recordtok)) | (1 << (M2Reserved_builtintok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Error_DefaultProcedure ();
  Builtin (stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
  P2SymBuild_StartBuildProcedure ();
  M2Debug_Assert (SymbolTable_IsProcedure (M2Quads_OperandT (1)));
  P2SymBuild_StartBuildFormalParameters ();
  if (M2LexBuf_currenttoken == M2Reserved_lparatok)
    {
      DefFormalParameters (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  P2SymBuild_EndBuildFormalParameters ();
  AttributeNoReturn (stopset0, stopset1, stopset2);
  P2SymBuild_BuildProcedureHeading ();
  M2Error_LeaveErrorScope ();
}


/*
   AttributeNoReturn := [ ''  ] 

   first  symbols:ldirectivetok
   
   reachend
*/

static void AttributeNoReturn (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_ldirectivetok)
    {
      Expect (M2Reserved_ldirectivetok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      M2Quads_PushAutoOn ();
      Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rdirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
      M2Quads_PopAuto ();
      checkReturnAttribute ();
      M2Debug_Assert (SymbolTable_IsProcedure (M2Quads_OperandT (1)));
      P2SymBuild_BuildNoReturnAttribute (M2Quads_OperandT (1));
      Expect (M2Reserved_rdirectivetok, stopset0, stopset1, stopset2);
    }
}


/*
   AttributeUnused := [ ''  ] 

   first  symbols:ldirectivetok
   
   reachend
*/

static void AttributeUnused (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_ldirectivetok)
    {
      Expect (M2Reserved_ldirectivetok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      M2Quads_PushAutoOn ();
      Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rdirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
      M2Quads_PopAuto ();
      checkParameterAttribute ();
      Expect (M2Reserved_rdirectivetok, stopset0, stopset1, stopset2);
    }
}


/*
   ProcedureBlock := 
                     % Assert(IsProcedure(OperandT(1)))  %
                     { 
                       % Assert(IsProcedure(OperandT(1)))  %
                       Declaration 
                       % Assert(IsProcedure(OperandT(1)))  %
                        } [ 'BEGIN' ProcedureBlockBody  ] 
                     'END' 
                     % Assert(IsProcedure(OperandT(1)))  %
                     

   first  symbols:proceduretok, moduletok, consttok, typetok, vartok, endtok, begintok
   
   cannot reachend
*/

static void ProcedureBlock (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  M2Debug_Assert (SymbolTable_IsProcedure (M2Quads_OperandT (1)));
  while ((((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P2Build_SetOfStop1) ((1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok))))) != 0))) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))))) != 0))))
    {
      M2Debug_Assert (SymbolTable_IsProcedure (M2Quads_OperandT (1)));
      Declaration (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_begintok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
      M2Debug_Assert (SymbolTable_IsProcedure (M2Quads_OperandT (1)));
    }
   /* while  */
  if (M2LexBuf_currenttoken == M2Reserved_begintok)
    {
      Expect (M2Reserved_begintok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_excepttok-M2Reserved_arraytok)) | (1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
      ProcedureBlockBody (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
    }
  Expect (M2Reserved_endtok, stopset0, stopset1, stopset2);
  M2Debug_Assert (SymbolTable_IsProcedure (M2Quads_OperandT (1)));
}


/*
   Block := { Declaration  } InitialBlock FinalBlock 
            'END' 

   first  symbols:proceduretok, moduletok, finallytok, begintok, consttok, typetok, vartok, endtok
   
   cannot reachend
*/

static void Block (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  while ((((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P2Build_SetOfStop1) ((1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok))))) != 0))) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))))) != 0))))
    {
      Declaration (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_finallytok-M2Reserved_arraytok)) | (1 << (M2Reserved_begintok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
    }
   /* while  */
  InitialBlock (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_finallytok-M2Reserved_arraytok))), stopset2);
  FinalBlock (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
  Expect (M2Reserved_endtok, stopset0, stopset1, stopset2);
}


/*
   InitialBlock := [ 'BEGIN' 
                     % BlockBegin (GetTokenNo () -1)  %
                     InitialBlockBody  ] 

   first  symbols:begintok
   
   reachend
*/

static void InitialBlock (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_begintok)
    {
      Expect (M2Reserved_begintok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_excepttok-M2Reserved_arraytok)) | (1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
      P2SymBuild_BlockBegin ((M2LexBuf_GetTokenNo ())-1);
      InitialBlockBody (stopset0, stopset1, stopset2);
    }
}


/*
   FinalBlock := [ 'FINALLY' 
                   % BlockFinally (GetTokenNo () -1)  %
                   FinalBlockBody  ] 

   first  symbols:finallytok
   
   reachend
*/

static void FinalBlock (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_finallytok)
    {
      Expect (M2Reserved_finallytok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_excepttok-M2Reserved_arraytok)) | (1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
      P2SymBuild_BlockFinally ((M2LexBuf_GetTokenNo ())-1);
      FinalBlockBody (stopset0, stopset1, stopset2);
    }
}


/*
   InitialBlockBody := NormalPart [ 'EXCEPT' 
                                    % PutExceptionBlock(GetCurrentScope())  %
                                    ExceptionalPart  ] 

   first  symbols:identtok, iftok, casetok, whiletok, repeattok, looptok, fortok, withtok, asmtok, retrytok, semicolontok, exittok, returntok, excepttok
   
   reachend
*/

static void InitialBlockBody (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  NormalPart (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_excepttok-M2Reserved_arraytok))), stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_excepttok)
    {
      Expect (M2Reserved_excepttok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      SymbolTable_PutExceptionBlock (SymbolTable_GetCurrentScope ());
      ExceptionalPart (stopset0, stopset1, stopset2);
    }
}


/*
   FinalBlockBody := NormalPart [ 'EXCEPT' 
                                  % PutExceptionFinally(GetCurrentScope())  %
                                  ExceptionalPart  ] 

   first  symbols:identtok, iftok, casetok, whiletok, repeattok, looptok, fortok, withtok, asmtok, retrytok, semicolontok, exittok, returntok, excepttok
   
   reachend
*/

static void FinalBlockBody (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  NormalPart (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_excepttok-M2Reserved_arraytok))), stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_excepttok)
    {
      Expect (M2Reserved_excepttok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      SymbolTable_PutExceptionFinally (SymbolTable_GetCurrentScope ());
      ExceptionalPart (stopset0, stopset1, stopset2);
    }
}


/*
   ProcedureBlockBody := NormalPart [ 'EXCEPT' 
                                      % PutExceptionBlock(GetCurrentScope())  %
                                      ExceptionalPart  ] 

   first  symbols:identtok, iftok, casetok, whiletok, repeattok, looptok, fortok, withtok, asmtok, retrytok, semicolontok, exittok, returntok, excepttok
   
   reachend
*/

static void ProcedureBlockBody (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  NormalPart (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_excepttok-M2Reserved_arraytok))), stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_excepttok)
    {
      Expect (M2Reserved_excepttok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      SymbolTable_PutExceptionBlock (SymbolTable_GetCurrentScope ());
      ExceptionalPart (stopset0, stopset1, stopset2);
    }
}


/*
   NormalPart := StatementSequence 

   first  symbols:retrytok, asmtok, withtok, fortok, looptok, repeattok, whiletok, casetok, iftok, identtok, returntok, exittok, semicolontok
   
   reachend
*/

static void NormalPart (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  StatementSequence (stopset0, stopset1, stopset2);
}


/*
   ExceptionalPart := StatementSequence 

   first  symbols:retrytok, asmtok, withtok, fortok, looptok, repeattok, whiletok, casetok, iftok, identtok, returntok, exittok, semicolontok
   
   reachend
*/

static void ExceptionalPart (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  StatementSequence (stopset0, stopset1, stopset2);
}


/*
   Declaration := 'CONST' { ConstantDeclaration ';'  }  | 
                  'TYPE' { TypeDeclaration ';'  }  | 
                  'VAR' { VariableDeclaration ';'  }  | 
                  ProcedureDeclaration ';'  | 
                  ModuleDeclaration ';' 

   first  symbols:moduletok, proceduretok, vartok, typetok, consttok
   
   cannot reachend
*/

static void Declaration (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_consttok)
    {
      Expect (M2Reserved_consttok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      while (M2LexBuf_currenttoken == M2Reserved_identtok)
        {
          ConstantDeclaration (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
          Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
        }
       /* while  */
    }
  else if (M2LexBuf_currenttoken == M2Reserved_typetok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_typetok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      while (M2LexBuf_currenttoken == M2Reserved_identtok)
        {
          TypeDeclaration (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
          Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
        }
       /* while  */
    }
  else if (M2LexBuf_currenttoken == M2Reserved_vartok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_vartok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      while (M2LexBuf_currenttoken == M2Reserved_identtok)
        {
          VariableDeclaration (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
          Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
        }
       /* while  */
    }
  else if (M2LexBuf_currenttoken == M2Reserved_proceduretok)
    {
      /* avoid dangling else.  */
      ProcedureDeclaration (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_moduletok)
    {
      /* avoid dangling else.  */
      ModuleDeclaration (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KMODULE} {%KPROCEDURE} {%KVAR} {%KTYPE} {%KCONST}", 69);
    }
}


/*
   DefFormalParameters := '(' [ DefMultiFPSection  ] 
                          
                          % VAR n: CARDINAL;  %
                          
                          % PopT(n) ;  remove param count   %
                          ')' FormalReturn 
                          % PushT(n) ;  restore param count   %
                          

   first  symbols:lparatok
   
   cannot reachend
*/

static void DefFormalParameters (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  unsigned int n;

  Expect (M2Reserved_lparatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_periodperiodperiodtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
  if ((M2LexBuf_currenttoken == M2Reserved_lsbratok) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_periodperiodperiodtok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))))) != 0))))
    {
      DefMultiFPSection (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  M2Quads_PopT (&n);  /* remove param count  */
  Expect (M2Reserved_rparatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);  /* remove param count  */
  FormalReturn (stopset0, stopset1, stopset2);
  M2Quads_PushT (n);  /* restore param count  */
}


/*
   DefMultiFPSection := DefExtendedFP  | 
                        FPSection [ ';' DefMultiFPSection  ] 

   first  symbols:identtok, vartok, lsbratok, periodperiodperiodtok
   
   cannot reachend
*/

static void DefMultiFPSection (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if ((M2LexBuf_currenttoken == M2Reserved_lsbratok) || (M2LexBuf_currenttoken == M2Reserved_periodperiodperiodtok))
    {
      DefExtendedFP (stopset0, stopset1, stopset2);
    }
  else if ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))))) != 0)))
    {
      /* avoid dangling else.  */
      FPSection (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
      if (M2LexBuf_currenttoken == M2Reserved_semicolontok)
        {
          Expect (M2Reserved_semicolontok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_periodperiodperiodtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
          DefMultiFPSection (stopset0, stopset1, stopset2);
        }
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%Kidentifier} {%KVAR} {%K...} {%K[}", 54);
    }
}


/*
   FormalParameters := '(' [ MultiFPSection  ] 
                       % VAR n: CARDINAL;  %
                       
                       % PopT(n) ;  remove param count   %
                       ')' FormalReturn 
                       % PushT(n) ;  restore param count   %
                       

   first  symbols:lparatok
   
   cannot reachend
*/

static void FormalParameters (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  unsigned int n;

  Expect (M2Reserved_lparatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_periodperiodperiodtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
  if ((M2LexBuf_currenttoken == M2Reserved_lsbratok) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_periodperiodperiodtok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))))) != 0))))
    {
      MultiFPSection (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  M2Quads_PopT (&n);  /* remove param count  */
  Expect (M2Reserved_rparatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);  /* remove param count  */
  FormalReturn (stopset0, stopset1, stopset2);
  M2Quads_PushT (n);  /* restore param count  */
}


/*
   MultiFPSection := ExtendedFP  | FPSection [ ';' 
                                               MultiFPSection  ] 

   first  symbols:identtok, vartok, lsbratok, periodperiodperiodtok
   
   cannot reachend
*/

static void MultiFPSection (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if ((M2LexBuf_currenttoken == M2Reserved_lsbratok) || (M2LexBuf_currenttoken == M2Reserved_periodperiodperiodtok))
    {
      ExtendedFP (stopset0, stopset1, stopset2);
    }
  else if ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))))) != 0)))
    {
      /* avoid dangling else.  */
      FPSection (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
      if (M2LexBuf_currenttoken == M2Reserved_semicolontok)
        {
          Expect (M2Reserved_semicolontok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_periodperiodperiodtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
          MultiFPSection (stopset0, stopset1, stopset2);
        }
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%Kidentifier} {%KVAR} {%K...} {%K[}", 54);
    }
}


/*
   FPSection := NonVarFPSection  | 
                VarFPSection 

   first  symbols:vartok, identtok
   
   cannot reachend
*/

static void FPSection (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_identtok)
    {
      NonVarFPSection (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_vartok)
    {
      /* avoid dangling else.  */
      VarFPSection (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KVAR} {%Kidentifier}", 40);
    }
}


/*
   DefExtendedFP := DefOptArg  | '...' 
                    % BuildVarArgs  %
                    

   first  symbols:lsbratok, periodperiodperiodtok
   
   cannot reachend
*/

static void DefExtendedFP (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
    {
      DefOptArg (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_periodperiodperiodtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_periodperiodperiodtok, stopset0, stopset1, stopset2);
      P2SymBuild_BuildVarArgs ();
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%K...} {%K[}", 31);
    }
}


/*
   ExtendedFP := OptArg  | '...' 
                 % BuildVarArgs  %
                 

   first  symbols:lsbratok, periodperiodperiodtok
   
   cannot reachend
*/

static void ExtendedFP (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
    {
      OptArg (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_periodperiodperiodtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_periodperiodperiodtok, stopset0, stopset1, stopset2);
      P2SymBuild_BuildVarArgs ();
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%K...} {%K[}", 31);
    }
}


/*
   OptArg := '[' 
             % VAR n: CARDINAL ;  %
             
             % PopT(n)  %
             
             % PushT(NulTok)  %
             Ident 
             % PushT(1)  %
             ':' FormalType 
             % PushT(n)  %
             
             % BuildFPSection  %
             
             % BuildOptArg  %
             [ '=' ConstExpression  ] ']' 

   first  symbols:lsbratok
   
   cannot reachend
*/

static void OptArg (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  unsigned int n;

  Expect (M2Reserved_lsbratok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Quads_PopT (&n);
  M2Quads_PushT (M2Reserved_NulTok);
  Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
  M2Quads_PushT (static_cast<unsigned int> (1));
  Expect (M2Reserved_colontok, stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  FormalType (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_equaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_rsbratok-M2Reserved_eoftok))), stopset1, stopset2);
  M2Quads_PushT (n);
  P2SymBuild_BuildFPSection ();
  P2SymBuild_BuildOptArg ();
  if (M2LexBuf_currenttoken == M2Reserved_equaltok)
    {
      Expect (M2Reserved_equaltok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      ConstExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rsbratok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  Expect (M2Reserved_rsbratok, stopset0, stopset1, stopset2);
}


/*
   DefOptArg := '[' 
                % VAR n: CARDINAL ;  %
                
                % PopT(n)  %
                
                % PushT(NulTok)  %
                Ident 
                % PushT(1)  %
                ':' FormalType 
                % PushT(n)  %
                
                % BuildFPSection  %
                
                % BuildOptArg  %
                '=' ConstExpression ']' 

   first  symbols:lsbratok
   
   cannot reachend
*/

static void DefOptArg (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  unsigned int n;

  Expect (M2Reserved_lsbratok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Quads_PopT (&n);
  M2Quads_PushT (M2Reserved_NulTok);
  Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
  M2Quads_PushT (static_cast<unsigned int> (1));
  Expect (M2Reserved_colontok, stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  FormalType (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_equaltok-M2Reserved_eoftok))), stopset1, stopset2);
  M2Quads_PushT (n);
  P2SymBuild_BuildFPSection ();
  P2SymBuild_BuildOptArg ();
  Expect (M2Reserved_equaltok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
  ConstExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rsbratok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_rsbratok, stopset0, stopset1, stopset2);
}


/*
   VarFPSection := 'VAR' 
                   % VAR n: CARDINAL ;  %
                   
                   % PopT(n) ;  %
                   
                   % PushT(VarTok) ;  %
                   IdentList ':' FormalType 
                   % PushT(n)  %
                   [ AttributeUnused  ] 
                   % BuildFPSection  %
                   

   first  symbols:vartok
   
   cannot reachend
*/

static void VarFPSection (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  unsigned int n;

  Expect (M2Reserved_vartok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Quads_PopT (&n);
  M2Quads_PushT (M2Reserved_VarTok);
  IdentList (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_colontok, stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  FormalType (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
  M2Quads_PushT (n);
  if (M2LexBuf_currenttoken == M2Reserved_ldirectivetok)
    {
      AttributeUnused (stopset0, stopset1, stopset2);
    }
  P2SymBuild_BuildFPSection ();
}


/*
   NonVarFPSection := 
                      % VAR n: CARDINAL ;  %
                      
                      % PopT(n)  %
                      
                      % PushT(NulTok)  %
                      IdentList ':' FormalType 
                      % PushT(n)  %
                      [ AttributeUnused  ] 
                      % BuildFPSection  %
                      

   first  symbols:identtok
   
   cannot reachend
*/

static void NonVarFPSection (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  unsigned int n;

  M2Quads_PopT (&n);
  M2Quads_PushT (M2Reserved_NulTok);
  IdentList (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_colontok, stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  FormalType (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
  M2Quads_PushT (n);
  if (M2LexBuf_currenttoken == M2Reserved_ldirectivetok)
    {
      AttributeUnused (stopset0, stopset1, stopset2);
    }
  P2SymBuild_BuildFPSection ();
}


/*
   FormalType := 'ARRAY' 'OF' 
                 % VAR n: CARDINAL ;  %
                 
                 % PushTF(ArrayTok, 1)  %
                 { 'ARRAY' 'OF' 
                   % PopTF(ArrayTok, n)  %
                   
                   % INC(n)  %
                   
                   % PushTF(ArrayTok, n)  %
                    } Qualident  | 
                 
                 % VAR Sym, Type: CARDINAL ;  %
                 Qualident 
                 % PopTF(Sym, Type) ;
                   PushT(NulTok) ;
                   PushTF(Sym, Type)  %
                 

   first  symbols:identtok, arraytok
   
   cannot reachend
*/

static void FormalType (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  unsigned int n;
  unsigned int Sym;
  unsigned int Type;

  if (M2LexBuf_currenttoken == M2Reserved_arraytok)
    {
      Expect (M2Reserved_arraytok, stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_oftok-M2Reserved_arraytok))), stopset2);
      Expect (M2Reserved_oftok, stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      M2Quads_PushTF (M2Reserved_ArrayTok, static_cast<unsigned int> (1));
      while (M2LexBuf_currenttoken == M2Reserved_arraytok)
        {
          Expect (M2Reserved_arraytok, stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_oftok-M2Reserved_arraytok))), stopset2);
          Expect (M2Reserved_oftok, stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
          M2Quads_PopTF (&M2Reserved_ArrayTok, &n);
          n += 1;
          M2Quads_PushTF (M2Reserved_ArrayTok, n);
        }
       /* while  */
      Qualident (stopset0, stopset1, stopset2);
    }
  else
    {
      Qualident (stopset0, stopset1, stopset2);
      M2Quads_PopTF (&Sym, &Type);
      M2Quads_PushT (M2Reserved_NulTok);
      M2Quads_PushTF (Sym, Type);
    }
}


/*
   ModuleDeclaration := 'MODULE' 
                        % M2Error.DefaultInnerModule  %
                        
                        % BlockStart (GetTokenNo () -1)  %
                        Ident 
                        % StartBuildInnerModule  %
                        [ Priority  ] ';' { Import 
                                            
                                            % BuildImportInnerModule  %
                                             } [ Export 
                                                 
                                                 % BuildExportInnerModule  %
                                                  ] 
                        Block 
                        % BlockEnd (GetTokenNo () -1)  %
                        Ident 
                        % EndBuildInnerModule  %
                        

   first  symbols:moduletok
   
   cannot reachend
*/

static void ModuleDeclaration (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_moduletok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Error_DefaultInnerModule ();
  P2SymBuild_BlockStart ((M2LexBuf_GetTokenNo ())-1);
  Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2);
  P2SymBuild_StartBuildInnerModule ();
  if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
    {
      Priority (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  Expect (M2Reserved_semicolontok, stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_importtok-M2Reserved_arraytok)) | (1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_exporttok-M2Reserved_arraytok)) | (1 << (M2Reserved_finallytok-M2Reserved_arraytok)) | (1 << (M2Reserved_begintok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
  while (((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P2Build_SetOfStop1) ((1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_importtok-M2Reserved_arraytok))))) != 0)))
    {
      Import (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_begintok-M2Reserved_arraytok)) | (1 << (M2Reserved_finallytok-M2Reserved_arraytok)) | (1 << (M2Reserved_exporttok-M2Reserved_arraytok)) | (1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_importtok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_vartok-M2Reserved_recordtok)) | (1 << (M2Reserved_typetok-M2Reserved_recordtok))));
      P2SymBuild_BuildImportInnerModule ();
    }
   /* while  */
  if (M2LexBuf_currenttoken == M2Reserved_exporttok)
    {
      Export (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_begintok-M2Reserved_arraytok)) | (1 << (M2Reserved_finallytok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_vartok-M2Reserved_recordtok)) | (1 << (M2Reserved_typetok-M2Reserved_recordtok))));
      P2SymBuild_BuildExportInnerModule ();
    }
  Block (stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  P2SymBuild_BlockEnd ((M2LexBuf_GetTokenNo ())-1);
  Ident (stopset0, stopset1, stopset2);
  P2SymBuild_EndBuildInnerModule ();
}


/*
   Priority := '[' ConstExpression ']' 

   first  symbols:lsbratok
   
   cannot reachend
*/

static void Priority (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_lsbratok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
  ConstExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rsbratok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_rsbratok, stopset0, stopset1, stopset2);
}


/*
   Export := 'EXPORT' ( 'QUALIFIED' 
                        % PushT(QualifiedTok)  %
                        IdentList  | 
                        'UNQUALIFIED' 
                        % PushT(UnQualifiedTok)  %
                        IdentList  | 
                        
                        % PushT(ExportTok)  %
                        IdentList  ) ';' 

   first  symbols:exporttok
   
   cannot reachend
*/

static void Export (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_exporttok, stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_qualifiedtok-M2Reserved_arraytok)) | (1 << (M2Reserved_unqualifiedtok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  if (M2LexBuf_currenttoken == M2Reserved_qualifiedtok)
    {
      Expect (M2Reserved_qualifiedtok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      M2Quads_PushT (M2Reserved_QualifiedTok);
      IdentList (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_unqualifiedtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_unqualifiedtok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      M2Quads_PushT (M2Reserved_UnQualifiedTok);
      IdentList (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      M2Quads_PushT (M2Reserved_ExportTok);
      IdentList (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2);
}


/*
   Import := 'FROM' Ident 'IMPORT' IdentList ';'  | 
             'IMPORT' 
             % PushT(ImportTok)
                                                                                             determines whether Ident or Module   %
             IdentList ';' 

   first  symbols:importtok, fromtok
   
   cannot reachend
*/

static void Import (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_fromtok)
    {
      Expect (M2Reserved_fromtok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Ident (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_importtok-M2Reserved_arraytok))), stopset2);
      Expect (M2Reserved_importtok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      IdentList (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_importtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_importtok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      /* determines whether Ident or Module  */
      M2Quads_PushT (M2Reserved_ImportTok);
      IdentList (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KIMPORT} {%KFROM}", 37);
    }
}


/*
   DefinitionModule := 'DEFINITION' 
                       % M2Error.DefaultDefinitionModule  %
                       'MODULE' [ 'FOR' string  ] Ident 
                       
                       % P2StartBuildDefModule  %
                       ';' { Import 
                             % BuildImportOuterModule  %
                              } [ Export 
                                  % BuildExportOuterModule  %
                                   ] { Definition  } 
                       'END' Ident 
                       % P2EndBuildDefModule  %
                       '.' 

   first  symbols:definitiontok
   
   cannot reachend
*/

static void DefinitionModule (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_definitiontok, stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_moduletok-M2Reserved_arraytok))), stopset2);
  M2Error_DefaultDefinitionModule ();
  Expect (M2Reserved_moduletok, stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  if (M2LexBuf_currenttoken == M2Reserved_fortok)
    {
      Expect (M2Reserved_fortok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      string (stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
    }
  Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
  P2SymBuild_P2StartBuildDefModule ();
  Expect (M2Reserved_semicolontok, stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_importtok-M2Reserved_arraytok)) | (1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_exporttok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_vartok-M2Reserved_recordtok)) | (1 << (M2Reserved_typetok-M2Reserved_recordtok))));
  while (((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P2Build_SetOfStop1) ((1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_importtok-M2Reserved_arraytok))))) != 0)))
    {
      Import (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_exporttok-M2Reserved_arraytok)) | (1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_importtok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
      P2SymBuild_BuildImportOuterModule ();
    }
   /* while  */
  if (M2LexBuf_currenttoken == M2Reserved_exporttok)
    {
      Export (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
      P2SymBuild_BuildExportOuterModule ();
    }
  while ((((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P2Build_SetOfStop1) ((1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok))))) != 0))) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))))) != 0))))
    {
      Definition (stopset0, stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
    }
   /* while  */
  Expect (M2Reserved_endtok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_periodtok-M2Reserved_eoftok))), stopset1, stopset2);
  P2SymBuild_P2EndBuildDefModule ();
  Expect (M2Reserved_periodtok, stopset0, stopset1, stopset2);
}


/*
   Definition := 'CONST' { ConstantDeclaration ';'  }  | 
                 'TYPE' { Ident ( ';'  | '=' Type Alignment 
                                  
                                  % BuildVarAlignment  %
                                  ';'  ) 
                          % BuildTypeEnd  %
                           }  | 
                 'VAR' { VariableDeclaration ';'  }  | 
                 DefProcedureHeading ';' 

   first  symbols:proceduretok, vartok, typetok, consttok
   
   cannot reachend
*/

static void Definition (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_consttok)
    {
      Expect (M2Reserved_consttok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      while (M2LexBuf_currenttoken == M2Reserved_identtok)
        {
          ConstantDeclaration (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
          Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
        }
       /* while  */
    }
  else if (M2LexBuf_currenttoken == M2Reserved_typetok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_typetok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      while (M2LexBuf_currenttoken == M2Reserved_identtok)
        {
          Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok)) | (1 << (M2Reserved_equaltok-M2Reserved_eoftok))), stopset1, stopset2);
          if (M2LexBuf_currenttoken == M2Reserved_semicolontok)
            {
              Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
            }
          else if (M2LexBuf_currenttoken == M2Reserved_equaltok)
            {
              /* avoid dangling else.  */
              Expect (M2Reserved_equaltok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_pointertok-M2Reserved_arraytok)) | (1 << (M2Reserved_packedsettok-M2Reserved_arraytok)) | (1 << (M2Reserved_oftok-M2Reserved_arraytok)) | (1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_settok-M2Reserved_recordtok)) | (1 << (M2Reserved_recordtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
              Type (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok)) | (1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
              Alignment (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
              P2SymBuild_BuildVarAlignment ();
              Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
            }
          else
            {
              /* avoid dangling else.  */
              ErrorArray ((const char *) "expecting one of: {%K=} {%K;}", 29);
            }
          P2SymBuild_BuildTypeEnd ();
        }
       /* while  */
    }
  else if (M2LexBuf_currenttoken == M2Reserved_vartok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_vartok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      while (M2LexBuf_currenttoken == M2Reserved_identtok)
        {
          VariableDeclaration (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
          Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
        }
       /* while  */
    }
  else if (M2LexBuf_currenttoken == M2Reserved_proceduretok)
    {
      /* avoid dangling else.  */
      DefProcedureHeading (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KPROCEDURE} {%KVAR} {%KTYPE} {%KCONST}", 58);
    }
}


/*
   AsmStatement := 'ASM' [ 'VOLATILE'  ] '(' AsmOperands 
                   ')' 

   first  symbols:asmtok
   
   cannot reachend
*/

static void AsmStatement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_asmtok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_volatiletok-M2Reserved_recordtok))));
  if (M2LexBuf_currenttoken == M2Reserved_volatiletok)
    {
      Expect (M2Reserved_volatiletok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  Expect (M2Reserved_lparatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
  AsmOperands (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
}


/*
   NamedOperand := '[' Ident ']' 

   first  symbols:lsbratok
   
   cannot reachend
*/

static void NamedOperand (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_lsbratok, stopset0, stopset1, stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Ident (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rsbratok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_rsbratok, stopset0, stopset1, stopset2);
}


/*
   AsmOperandName := [ NamedOperand  ] 

   first  symbols:lsbratok
   
   reachend
*/

static void AsmOperandName (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
    {
      NamedOperand (stopset0, stopset1, stopset2);
    }
}


/*
   AsmOperands := ConstExpression ':' AsmList [ ':' 
                                                AsmList 
                                                [ ':' 
                                                  TrashList  ]  ] 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void AsmOperands (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  ConstExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_colontok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok)) | (1 << (M2Reserved_commatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
  AsmList (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_colontok)
    {
      Expect (M2Reserved_colontok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok)) | (1 << (M2Reserved_commatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      AsmList (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
      if (M2LexBuf_currenttoken == M2Reserved_colontok)
        {
          Expect (M2Reserved_colontok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
          TrashList (stopset0, stopset1, stopset2);
        }
    }
}


/*
   AsmList := [ AsmElement  ] { ',' AsmElement  } 

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok, lsbratok, commatok
   
   reachend
*/

static void AsmList (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_nottok)) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))))) != 0))))
    {
      AsmElement (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
      AsmElement (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
   /* while  */
}


/*
   AsmElement := AsmOperandName ConstExpression '(' 
                 Expression ')' 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok, lsbratok
   
   cannot reachend
*/

static void AsmElement (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  AsmOperandName (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
  ConstExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_lparatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Expression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
}


/*
   TrashList := [ ConstExpression  ] { ',' ConstExpression  } 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok, commatok
   
   reachend
*/

static void TrashList (P2Build_SetOfStop0 stopset0, P2Build_SetOfStop1 stopset1, P2Build_SetOfStop2 stopset2)
{
  if ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P2Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_nottok)) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P2Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))))) != 0))))
    {
      ConstExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P2Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P2Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      ConstExpression (stopset0|(P2Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
   /* while  */
}


/*
   CompilationUnit - returns TRUE if the input was correct enough to parse
                     in future passes.
*/

extern "C" bool P2Build_CompilationUnit (void)
{
  WasNoError = true;
  FileUnit ((P2Build_SetOfStop0) ((1 << (M2Reserved_eoftok-M2Reserved_eoftok))), (P2Build_SetOfStop1) 0, (P2Build_SetOfStop2) 0);
  return WasNoError;
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}

extern "C" void _M2_P2Build_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
{
}

extern "C" void _M2_P2Build_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
{
}
